/*******************************************************************************
 *
 *                           CARTOUCHE PVCS
 *
 *******************************************************************************
 *
 * $Workfile:   bibmouse.c  $
 * $Revision:   1.0  $
 * $Modtime:   04 Mar 1996 14:05:42  $
 *
 * $Log:   F:\gesconf\library\bibmouse\bibmouse.c_v  $
 *
 *    Rev 1.0   04 Mar 1996 14:16:38   pg
 * Mise en configuration sous PVCS
 *
 ******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* DESCRIPTION DE LA BIBIOTHEQUE BIBMOUSE (bibliotheque souris)               */
/*                                                                            */
/******************************************************************************/
/* Auteur               : E. GUIGNIER                                         */
/* Date                 : 22.08.92                                            */
/* Dernire mise--jour :                                                     */
/*                                                                            */
/*    22.08.92 : Cration de la bibliothque                                  */
/*    03.12.94 : Reformatage de la bibliotheque -> indpendante               */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
/*                  LISTE DES SERVICES DE LA BIBLIOTHEQUE                     */
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                             BIBMOUSE.C                                     */
/*                             ----------                                     */
/*                                                                            */
/*                InitSouris()                                                */
/*                AllumeCurseurSouris()                                       */
/*                EteintCurseurSouris()                                       */
/*                PositionEtatSouris()                                        */
/*                PositionnementSouris()                                      */
/*                DetectionEnfoncementBouton()                                */
/*                DetectionRelachementBouton()                                */
/*                LimiteSourisX()                                             */
/*                LimiteSourisY()                                             */
/*                ChangementCurseurGraphique()                                */
/*                ChangementCurseurTexte()                                    */
/*                BranchementSousProgramme()                                  */
/*                VitesseSouris()                                             */
/*                ZoneExclusionSouris()                                       */
/*                ChangeSousProgramme()                                       */
/*                TailleTampon()                                              */
/*                SauveEtatPilote()                                           */
/*                RestaureEtatPilote()                                        */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
/**/

/*== Includes sytemes ncessaires  la bibliothque ==========================*/



/*== Includes non-systmes ncessaires  la bibliothque =====================*/

#include "francais.h"
#include "bibmouse.h"


/*== Constantes internes  la bibliothque ===================================*/

typedef void (far * MOUHANDLERPTR)(void);


/*== Prototypes des fonctions importes pour la bibliothque =================*/

extern void far FSOURIS(void *,void *,void *,void *);
extern void far ASSHAND(void);


/*== Prototypes des fonctions et procdures internes  la bibliothque =======*/

PROCEDURE EVENEMENT(int MasqueEv,int EtBouton,int PosX,int PosY);


/*== Variables globales  exporter de la bibliothque ========================*/

int MasqueEvenement;                /* Evenement dtect                      */
int EtatBoutons;                    /* 1:gauche, 2:droit, 3:les deux, ...     */
int Xsouris;                        /* abscisse x dans plan graphique virtuel */
int Ysouris;                        /* ordonne y dans plan graphique virtuel */

/*== Variables globales internes de la bibliothque ==========================*/

static TableauEtatPilote[512];      /* sauvergarde de l'tat du pilote        */

/**/
/******************************************************************************/
/************** CORPS DES FONCTIONS INTERNES DE LA BIBLIOTHEQUE ***************/
/******************************************************************************/






/**/
/******************************************************************************/
/****** CORPS DES FONCTIONS ET PROCEDURES INTER_MODULES DE LA BIBLIOTHEQUE ****/
/******************************************************************************/


/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : Evenement                                    */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Cette Fonction est directement appele par le gestionnaire           */
/*       d'vnements, qui lui-mme est appel par le driver MOUSE.COM        */
/*       lors de l'vnement :                                                */
/*                                                                            */
/*            - Un des boutons a t appuy                                   */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* MasqueEv      |X| | |    int     |             | Masque evenement reu     */
/*               | | | |            |             |                           */
/* EtBouton      |X| | |    int     |             | Etat des boutons          */
/*               | | | |            |             |                           */
/* PosX          |X| | |    int     |             | Position X souris         */
/*               | | | |            |             |                           */
/* PosY          |X| | |    int     |             | Position Y souris         */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  APPEL INTERDIT (uniquement pour le gestionnaire)                          */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : Evenement                                     */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/*  Dpiler les arguments passs par le gestionnaire                          */
/*  Les mmoriser dans les variables globales                                 */
/*                                                                            */
/******************************************************************************/
#pragma check_stack(off)

PROCEDURE EVENEMENT(int MasqueEv,int EtBouton,int PosX,int PosY)
debut
  MasqueEvenement = MasqueEv;
  EtatBoutons     = EtBouton;
  Xsouris         = PosX;
  Ysouris         = PosY;
fin

#pragma check_stack
#pragma check_stack




/**/
/******************************************************************************/
/***************** CORPS DES SERVICES DE LA BIBLIOTHEQUE **********************/
/******************************************************************************/



/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : InitSouris                                   */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Initialiser le pilote souris                                         */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  InitSouris()                                                              */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : InitSouris                                    */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 0                                               */
/*                                                                            */
/******************************************************************************/

PROCEDURE InitSouris(void)
debut
  int m1,m2,m3,m4;

  m1 = 0;
  FSOURIS(&m1,&m2,&m3,&m4);
fin




/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : AllumeCurseurSouris                          */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Allume le curseur de la souris et annule toute zone d'exclusion      */
/*       definie prcdemment                                                 */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* AllumeCurseurSouris()                                                      */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : AllumeCurseurSouris                           */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 1                                               */
/*                                                                            */
/******************************************************************************/

PROCEDURE AllumeCurseurSouris(void)
debut
  int m1,m2,m3,m4;

  m1 = 1;
  FSOURIS(&m1,&m2,&m3,&m4);
fin





/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : EteintCurseurSouris                          */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Eteint le curseur de la souris                                       */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* EteintCurseurSouris()                                                      */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : EteintCurseurSouris                           */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 2                                               */
/*                                                                            */
/******************************************************************************/

PROCEDURE EteintCurseurSouris(void)
debut
  int m1,m2,m3,m4;

  m1 = 2;
  FSOURIS(&m1,&m2,&m3,&m4);
fin





/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : PositionEtatSouris                           */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Permet de connaitre la position du curseur et l'tat des boutons     */
/*                                                                            */
/*             bouton = 0  :  aucun bouton                                    */
/*                      1  :  bouton gauche                                   */
/*                      2  :  bouton droit                                    */
/*                      3  :  les deux boutons                                */
/*                      4  :  troisime bouton ....                                                      */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* EtBouton      | |X| |   int *    |             | Etat bouton               */
/*               | | | |            |             |                           */
/* PosX          | |X| |   int *    |             | Position X curseur        */
/*               | | | |            |             |                           */
/* PoxY          | |X| |   int *    |             | Position Y curseur        */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  PositionEtatSouris(&Bouton,&X,&Y)                                         */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : PositionEtatSouris                            */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 3                                               */
/*                                                                            */
/******************************************************************************/

PROCEDURE PositionEtatSouris(int * EtBouton,int * PosX, int * PosY)
debut
  int m1;

  m1 = 3;
  FSOURIS(&m1,EtBouton,PosX,PosY);
fin




/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : PositionnementCurseur                        */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Positionne le curseur de la souris sur l'cran                       */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* PosX          |X| | |  int       |             | Position X curseur        */
/*               | | | |            |             |                           */
/* PosY          |X| | |  int       |             | Position Y curseur        */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  PositionnementCurseur(12,23)                                              */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : PositionnementCurseur                         */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 4                                               */
/*                                                                            */
/******************************************************************************/

PROCEDURE PositionnementCurseur(int PosX, int PosY)
debut
  int m1,m2,m3,m4;

  m1 = 4;
  m3 = PosX;
  m4 = PosY;
  FSOURIS(&m1,&m2,&m3,&m4);
fin





/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : DetectionEnfoncementBouton                   */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Detecte le changement d'tat ( l'enfoncement) d'un bouton souris    */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* NumBouton     |X| | |  int *     |             | Numero du bouton  tester */
/*               | | | |            |             |                           */
/* EtBouton      | |X| |  int *     |             | Etat bouton 1=chgt        */
/*               | | | |            |             |                           */
/* NbCliquage    | |X| |  int *     |             | Nb de cliquage            */
/*               | | | |            |             |                           */
/* PosX          | |X| |  int *     |             | position X curseur        */
/*               | | | |            |             |                           */
/* PosY          | |X| |  int *     |             | position Y curseur        */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  DetectionEnfoncementBouton(&Num,&Etat,&NbClic,&X,&Y)                      */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : DetectionEnfoncementBouton                    */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 5                                               */
/* Recuperer l'tat du bouton, le nb de cliquage et la position X et Y        */
/*                                                                            */
/******************************************************************************/

PROCEDURE DetectionEnfoncementBouton( int * NumBouton,int * EtBouton,
                                      int * NbCliquage, int * PosX, int * PosY )
debut
  int m1;

  m1 = 5;
  FSOURIS(&m1,NumBouton,PosX,PosY);
  * EtBouton = m1;
  * NbCliquage = * NumBouton;
fin





/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : DetectionRelachamentBouton                   */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Detecte le changement d'tat (au relachement)  d'un bouton souris    */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* NumBouton     |X| | |  int *     |             | Numero du bouton  tester */
/*               | | | |            |             |                           */
/* EtBouton      | |X| |  int *     |             | Etat bouton 1=chgt        */
/*               | | | |            |             |                           */
/* NbCliquage    | |X| |  int *     |             | Nb de cliquage            */
/*               | | | |            |             |                           */
/* PosX          | |X| |  int *     |             | position X curseur        */
/*               | | | |            |             |                           */
/* PosY          | |X| |  int *     |             | position Y curseur        */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  DetectionRelachementBouton(&Num,&Etat,&NbClic,&X,&Y)                      */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : DetectionRelachementBouton                    */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 6                                               */
/* Recuperer l'tat du bouton, le nb de cliquage et la position X et Y        */
/*                                                                            */
/******************************************************************************/

PROCEDURE DetectionRelachementBouton( int * NumBouton,int * EtBouton,
                                      int * NbCliquage, int * PosX, int * PosY )
debut
  int m1;

  m1 = 6;
  FSOURIS(&m1,NumBouton,PosX,PosY);
  * EtBouton = m1;
  * NbCliquage = * NumBouton;
fin





/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : LimiteSourisX                                */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Fixe les limites horizontales de la zone de deplacement du curseur   */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* LimGauche     | |X| |  int       |             | limite gauche             */
/*               | | | |            |             |                           */
/* LimDroite     | |X| |  int       |             | limite droite             */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* LimiteSourisX(12,45)                                                       */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : LimiteSourisX                                 */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/*  Appeler la fonction souris 7                                              */
/*                                                                            */
/******************************************************************************/

PROCEDURE LimiteSourisX(int LimGauche, int LimDroite)
debut
  int m1,m2,m3,m4;

  m1 = 7;
  m3 = LimGauche;
  m4 = LimDroite;
  FSOURIS(&m1,&m2,&m3,&m4);
fin




/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : LimiteSourisY                                */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Fixe les limites verticales   de la zone de deplacement du curseur   */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* LimHaute      | |X| |  int       |             | limite haute              */
/*               | | | |            |             |                           */
/* LimBasse      | |X| |  int       |             | limite basse              */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* LimiteSourisX(12,45)                                                       */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : LimiteSourisY                                 */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/*  Appeler la fonction souris 8                                              */
/*                                                                            */
/******************************************************************************/

PROCEDURE LimiteSourisY(int LimHaute, int LimBasse)
debut
  int m1,m2,m3,m4;

  m1 = 8;
  m3 = LimHaute;
  m4 = LimBasse;
  FSOURIS(&m1,&m2,&m3,&m4);
fin




/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : ChangementCurseurGraphique                   */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Redefinit la forme du curseur graphique et fixe  son point de        */
/*       rfrence                                                            */
/*                                                                            */
/*       DecX et DecY servent  positionner le point de rfrence du nouveau  */
/*       curseur graphique  +/- 16 pixels du coin suprieur gauche de        */
/*       celui-ci                                                             */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* DecX          |X| | |   int      |             |  decalage horizontal      */
/*               | | | |            |             |                           */
/* DecY          |X| | |   int      |             |  decalage vertical        */
/*               | | | |            |             |                           */
/* TabCurseur    |X| | |   int *    |             |  tableau nouveau curseur  */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* ChangementCurseurGraphique(0,0,&Tableau[0])                                */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : ChangementCurseurGraphique                    */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 9                                               */
/*                                                                            */
/******************************************************************************/

PROCEDURE ChangementCurseurGraphique(int DecX,int DecY,int * TabCurseur)
debut
  int m1,m2,m3;

  m1 = 9;
  m2 = DecX;
  m3 = DecY;

  FSOURIS(&m1,&m2,&m3,TabCurseur);
fin




/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : ChangementCurseurTexte                       */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Selectionne le type et la couleur du curseur texte                   */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* TypeCurseur   |X| | |   int      |             |  type de curseur          */
/*               | | | |            |             |    0 = Pav rectangulaire */
/*               | | | |            |             |    1 = Trait soulignement */
/*               | | | |            |             |                           */
/* MasqueEcran   |X| | |   int      |             |  masque d'cran           */
/*               | | | |            |             |                           */
/* MasqueCurseur |X| | |   int      |             |  masque du curseur        */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* ChangementCurseurTexte(0,0x7FFFF,0x4800)                                   */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : ChangementCurseurTexte                        */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 10                                              */
/*                                                                            */
/******************************************************************************/

PROCEDURE ChangementCurseurTexte(int TypeCurseur,int MasqueEcran,
                                 int MasqueCurseur)
debut
  int m1,m2,m3,m4;

  m1 = 10;
  m2 = TypeCurseur;
  m3 = MasqueEcran;
  m4 = MasqueCurseur;
  FSOURIS(&m1,&m2,&m3,&m4);
fin




/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : BranchementSousProgramme                     */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Active le branchement conditionnel vers un sous-programme            */
/*                                                                            */
/*            ex: procdure TOTO   offset = (int) &TOTO  (Modele SMALL)       */
/*                                                                            */
/*            Evenement activant l'interruption :                             */
/*                        bit 0 changement de position                        */
/*                        bit 1 Enfoncement du bouton G                       */
/*                        bit 2 Relachement du bouton G                       */
/*                        bit 3 Enfoncement du bouton D                       */
/*                        bit 4 Relachement du bouton D                       */
/*                                                                            */
/*             Passer du format binaire en dcimal...                         */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* Evenement     |X| | |    int     |             | Evenement conditionnel    */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  BranchementSousProgramme(8)                                               */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : BranchementSousProgramme                      */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 12                                              */
/*                                                                            */
/******************************************************************************/

PROCEDURE BranchementSousProgramme(int Evenement)
debut
  int m1,m2,m3;
  MOUHANDLERPTR m4;

  m1 = 12;
  m3 = Evenement;
  m4 = (MOUHANDLERPTR) &ASSHAND;
  FSOURIS(&m1,&m2,&m3,&m4);
fin



/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : VitesseSouris                                */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Fixe les vitesses horizontale et verticale de deplacement du curseur */
/*       Les vitesses s'expriment en mickeys pour 8 pixels                    */
/*                                                                            */
/*            nb de mickey / 8 pixels   ( 1 mickey=0.12mm )                   */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* VitHoriz      |X| | |    int     |             | vitesse horizontale       */
/*               | | | |            |             |                           */
/* VitVertic     |X| | |    int     |             | vitesse verticale         */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* VitesseSouris(32,32)                                                       */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : VitesseSouris                                 */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 15                                              */
/*                                                                            */
/******************************************************************************/

PROCEDURE VitesseSouris(int VitHoriz, int VitVertic)
debut
  int m1,m2,m3,m4;

  m1 = 15;
  m3 = VitHoriz;
  m4 = VitVertic;
  FSOURIS(&m1,&m2,&m3,&m4);

}


/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : ZoneExclusionSouris                          */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT :  Fixe les limites de la zone d'exclusion du curseur o il devient    */
/*        invisible. Il demeure invisible mme s'il en ressort !!! il faut    */
/*        utiliser la fonction <AllumeCurseurSouris> pour le rendre de        */
/*        nouveau visible                                                     */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* LimGauche     |X| | |   int      |             | Limite Gauche             */
/*               | | | |            |             |                           */
/* LimHaute      |X| | |   int      |             | Limite haute              */
/*               | | | |            |             |                           */
/* LimDroite     |X| | |   int      |             | Limite droite             */
/*               | | | |            |             |                           */
/* LimBasse      |X| | |   int      |             | Limite basse              */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* ZoneExclusionSouris(Tableau)                                               */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : ZoneExclusionSouris                           */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 16                                              */
/*                                                                            */
/******************************************************************************/

PROCEDURE ZoneExclusionSouris(int LimGauche, int LimHaute,
                              int LimDroite, int LimBasse)
debut
  int m1,m2,m3;
  int tab[4];

  m1 = 16;
  tab[0] = LimGauche;
  tab[1] = LimHaute;
  tab[2] = LimDroite;
  tab[3] = LimBasse;

  FSOURIS(&m1,&m2,&m3,tab);
fin


/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : ChangeSousProgramme                          */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Remplacement d'un sous-programme par un autre                        */
/*                                                                            */
/*             donner : nouvel evenement   (int)                              */
/*                      nouveau segment     ?                                 */
/*                      nouvel offset      (int) &...                         */
/*             rend:    ancien evenement                                      */
/*                      ancien segment                                        */
/*                      ancien offset                                         */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* Segment       |X|X| |   int *    |             | Segment du spgm           */
/*               | | | |            |             |                           */
/* Evenement     |X|X| |   int *    |             | Evenement conditionnel    */
/*               | | | |            |             |                           */
/* Offset        |X|X| |   int *    |             | Offset du spgm            */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  ChangementSousProgramme(&Seg,&Ev,&Offs)                                   */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : ChangementSousProgramme                       */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/*  Appeler la fonction souris 20                                             */
/*                                                                            */
/******************************************************************************/

PROCEDURE ChangeSousProgramme( int * Segment, int * Evenement, int * Offset )
debut
  int m1;

  m1 = 20;
  FSOURIS(&m1,Segment,Evenement,Offset);
fin



/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : TailleTampon                                 */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Determine la taille du registre tampon de sauvegarde de l'tat du    */
/*       pilote                                                               */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    |   int      |             | Taille tampon en Octets   */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  Taille = TailleTampon()                                                   */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : TailleTampon                                  */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/*  Appeler la fonction souris 21                                             */
/*                                                                            */
/******************************************************************************/

FONCTION int TailleTampon(void)
debut
  int m1,m2,m3,m4;

  m1 = 21;
  FSOURIS(&m1,&m2,&m3,&m4);
  return(m2);
fin




/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : SauveEtatPilote                              */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Assure la sauvegarde de l'tat du pilote de la souris                */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* Tampon        |X| | |   int *    |             | adresse du tableau        */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  SauveEtatPilote(Tab)                                                      */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : SauveEtatPilote                               */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 22                                              */
/*                                                                            */
/******************************************************************************/

PROCEDURE SauveEtatPilote(int * Tampon)
debut
  int m1,m2,m3;

  m1 = 22;
  FSOURIS(&m1,&m2,&m3,Tampon);
fin




/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : ResteEtatPilote                              */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Assure le rtablissement de l'tat du pilote de la souris            */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/* Tampon        |X| | |   int *    |             | adresse du tableau        */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  RestaureEtatPilote(Tab)                                                   */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : RestaureEtatPilote                            */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 23                                              */
/*                                                                            */
/******************************************************************************/

PROCEDURE RestaureEtatPilote(int * Tampon)
debut
  int m1,m2,m3;

  m1 = 23;
  FSOURIS(&m1,&m2,&m3,Tampon);
fin




/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : SauveEtatPiloteAsm                           */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Assure la sauvergarde de l'tat du pilote de la souris               */
/*       Sans passer par le programme assembler. Ici on attaque directement   */
/*       l'interruption 33h                                                   */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  SauveEtatPiloteAsm()                                                      */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : SauveEtatPiloteAsm                            */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 22 de l'interruption 33h                        */
/*                                                                            */
/******************************************************************************/

PROCEDURE SauveEtatPiloteAsm()
debut
  asm push es
  asm push di
  asm push dx

  asm mov ax,16H
  asm lea di,TableauEtatPilote
  asm mov dx,di
  asm int 33H

  asm pop dx
  asm pop di
  asm pop es
fin




/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : RestaureEtatPiloteAsm                        */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/
/* BUT : Assure la restauration de l'tat du pilote de la souris              */
/*       Sans passer par le programme assembler. Ici on attaque directement   */
/*       l'interruption 33h                                                   */
/*                                                                            */
/******************************************************************************/
/*    ARGUMENTS D'ENTREE OU DE SORTIE ET VARIABLES GLOBALES MODIFIEES         */
/*----------------------------------------------------------------------------*/
/* Nom de la     |E|S|G|  Type et   |   Valeurs   |    Signification          */
/* variable      | | | |  longueur  |  possibles  |                           */
/*----------------------------------------------------------------------------*/
/*               | | | |            |             |                           */
/*               | | | |            |             |                           */
/******************************************************************************/
/*                     |            |             |                           */
/* VALEUR RETOURNEE    | Aucune     |             |                           */
/*                     |            |             |                           */
/******************************************************************************/
/*                   EXEMPLE DE SEQUENCE d'APPEL :                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  RestaureEtatPiloteAsm()                                                   */
/*                                                                            */
/******************************************************************************/
/**/
/******************************************************************************/
/* ALGORITHME DE LA PROCEDURE : RestaureEtatPiloteAsm                         */
/* MODULE : BIBMOUSE                                                          */
/* AUTEUR : E.GUIGNIER                                                        */
/* DATE   : 22/08/92                                                          */
/* DERNIERE MISE A JOUR : 22/08/92                                            */
/******************************************************************************/
/*                                                                            */
/* Appeler la fonction souris 23 de l'interruption 33h                        */
/*                                                                            */
/******************************************************************************/

PROCEDURE RestaureEtatPiloteAsm()
debut
  asm push es
  asm push di
  asm push dx

  asm mov ax,17H
  asm lea di,TableauEtatPilote
  asm mov dx,di
  asm int 33H

  asm pop dx
  asm pop di
  asm pop es
fin

/**/
/******************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : MouInit                                      */
/* MODULE : BIBMOUSE                                                          */
/******************************************************************************/

FONCTION int MouInit(int Xmin,int Xmax,int Ymin,int Ymax,int Event)
debut
    InitSouris();
    LimiteSourisX(Xmin,Xmax);
    LimiteSourisY(Ymin,Ymax);
    VitesseSouris(8,16);
    BranchementSousProgramme(Event);  /* appuis des boutons 1,2 et 3 */
    retour(1);
fin

/******************************** FIN *****************************************/
