/*******************************************************************************
 * 
 *                           CARTOUCHE PVCS
 *
 *******************************************************************************
 *
 * $Workfile:   bibmouse.h  $
 * $Revision:   1.0  $
 * $Modtime:   04 Mar 1996 14:06:04  $
 *
 * $Log:   F:\gesconf\library\bibmouse\bibmouse.h_v  $
 * 
 *    Rev 1.0   04 Mar 1996 14:16:56   pg
 * Mise en configuration sous PVCS
 * 
 ******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Fichier BIBMOUSE.H  inclure dans le xxxCST.H de l'application             */
/*                                                                            */
/* Bibliotheque de fonctions d'adressage souris Microsoft                     */
/*                                                                            */
/******************************************************************************/
/* Auteur              : E. GUIGNIER                                          */
/* Date                : 22.08.92                                             */
/* Dernire mis--jour :                                                      */
/*                                                                            */
/*    22.08.92 : Cration de la bibliotheque                                  */
/*    03.12.94 : Reformatage de la bibliotheque -> indpendante               */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
                    
                    
#ifndef _BIBMOUSE_INCLUDED
#define _BIBMOUSE_INCLUDED
                    
/*== Includes systmes ncessaires  l'utilisateur ===========================*/  


/*== Includes non-systmes ncessaire  l'utilisateur ========================*/  

#include "francais.h"

/*== Constantes lies aux fonctions et procdures importes ==================*/


/*== Constantes lies aux fonctions et procdures exportes ==================*/

#define EV_MOUVEMENT    1    /* la souris a boug                             */
#define EV_GAUCHE_ENF   2    /* bouton gauche appuy                          */
#define EV_GAUCHE_REL   4    /* bouton gauche relach                         */
#define EV_DROIT_ENF    8    /* bouton droit enfonc                          */
#define EV_DROIT_REL   16    /* bouton droit relach                          */
#define EV_MILIEU_ENF  32    /* bouton milieu appuy                          */
#define EV_MILIEU_REL  64    /* bouton milieu relach                         */
#define EV_BOUTON_TOUS 126   /* tous les evenements boutons confondus         */
#define EV_SOURIS_TOUS 127   /* tous les evenements souris confondus          */


/*== Prototypes des fonctions et procdures importes ========================*/


/*== Prototypes des fonctions et procdures exportes ========================*/

extern FONCTION int TailleTampon(void);
extern FONCTION int MouInit(int Xmin,int Xmax,int Ymin,int Ymax,int Event);

extern PROCEDURE InitSouris(void);
extern PROCEDURE AllumeCurseurSouris(void);
extern PROCEDURE EteintCurseurSouris(void);
extern PROCEDURE PositionEtatSouris(int * EtBouton, int * PosX, int * PosY);
extern PROCEDURE PositionnementCurseur(int PosX, int PosY);
extern PROCEDURE DetectionEnfoncementBouton( int * NumBouton,int * EtBouton,
                                     int * NbCliquage, int * PosX, int * PosY);
extern PROCEDURE DetectionRelachementBouton( int * NumBouton,int * EtBouton,
                                     int * NbCliquage, int * PosX, int * PosY);
extern PROCEDURE LimiteSourisX(int LimGauche, int LimDroite);
extern PROCEDURE LimiteSourisY(int LimHaute ,int LimBasse);
extern PROCEDURE ChangementCurseurGraphique(int DecX,int DecY,int * TabCurseur);
extern PROCEDURE ChangementCurseurTexte(int TypeCurseur,int MasqueEcran,
                                        int MasqueCurseur);
extern PROCEDURE BranchementSousProgramme(int Evenement);
extern PROCEDURE VitesseSouris(int VitHoriz, int VitVertic);
extern PROCEDURE ZoneExclusionSouris(int LimGauche, int LimHaute,
                                     int LimDroite, int LimBasse);
extern PROCEDURE ChangeSousProgramme(int *Segment,int *Evenement,int *Offset);
extern PROCEDURE SauveEtatPilote(int * Tampon);
extern PROCEDURE RestaureEtatPilote(int * Tampon);
extern PROCEDURE SauveEtatPiloteAsm(void);
extern PROCEDURE RestaureEtatPiloteAsm(void);

                                                           
/*== Variables globales importes ============================================*/                                                          
                                             
                                             
/*== Variables globales exportes ============================================*/                                                          

extern int MasqueEvenement;         /* Evenement dtect                      */
extern int EtatBoutons;             /* 1:gauche, 2:droit, 3:les deux, ...     */
extern int Xsouris;                 /* abscisse x dans plan graphique virtuel */
extern int Ysouris;                 /* ordonne y dans plan graphique virtuel */

/*=============================== FIN ========================================*/

#endif /* _BIBMOUSE_INCLUDED */

