/******************************************************************************/
/*                                                                            */
/* Fichier BIBTRACE.H    a inclure dans le xxxCST.H de l'application          */
/*                                                                            */
/******************************************************************************/
/* Auteur               : Ph. RUELEN                                          */
/* Date                 : 27/04/95                                            */
/* Derniere mise a jour :                                                     */
/*                                                                            */
/*      27.04.95 : Creation de la bibliotheque                                */
/******************************************************************************/

#ifndef _BIBTRACE_INCLUDED
#define _BIBTRACE_INCLUDED

/*== Includes systemes necessaires a l'utilisateur ===========================*/


/*== Includes non-systemes necessaires a l'utilisateur =======================*/

#include <francais.h>


/*== Constantes liees aux fonctions et procedures importees ==================*/


/*== Constantes liees aux fonctions et procedures exportees ==================*/

#define TRACEPAR       "PARAM_TRACE"          /* nom de la var.d'environnement*/
                                              /* du fichier de parametrage    */
                                              /* des traces */

#define LG_FICHIER        256                 /* Taille nom de fichier        */
#define TRACE             COPIER_N(_Fich_,__FILE__,LG_FICHIER);\
                          _Ligne_=__LINE__;\
                          Trace

#define TRACE_RESET       0                   /* mode RESET                   */
#define TRACE_APPEND      1                   /* mode APPEND                  */

#define NIV_HANDLER       1                   /* Trace de niveau HANDLER      */

#define NIV_ENTREE        2                   /* Suggestion d'autres niveaux  */
#define NIV_SORTIE        3                   /* de trace */  
#define NIV_FIL_EAU       4
#define NIV_BOUCLE        5
#define NIV_TEST          6

#define SANS_CONSIGNE      0
#define SANS_IMPRIMANTE   '$'

typedef PROCEDURE (*T_PTR_FONC)(void);

                    /* Indices d'erreurs internes */

#define ERR_OUVRE_FICH      201   /* Erreur d'ouverture fichier    */
#define ERR_POSIT_FICH      202   /* Erreur de positionnement fich */
#define ERR_FERME_FICH      203   /* Erreur de fermeture fichier   */
#define PAS_FICH_TRACE      204   /* Fichier TRACE inexistant      */
#define MAUVAIS_PORT_IMPR   205   /* Mauvais port imprimante       */
#define MAUVAIS_MODE_TRACE  206   /* Mode incorrect                */
#define LECT_ENTETE_NOK     207   /* Lecture entete impossible     */
#define ECRI_ENTETE_NOK     208   /* Ecriture entete impossible    */
#define ERR_NIVEAU          209   /* Niveau de trace incorrect     */
#define VAL_ENTETE_NOK      210   /* Valeur(s) entete incorrecte(s)*/


/*== Prototypes des fonctions et procedures importees ========================*/

extern PROCEDURE Handler(char *origine, int erreur);


/*== Prototypes des fonctions et procedures exportees ========================*/

extern PROCEDURE InitTrace(char *nomFichierTrace,T_PTR_FONC foncNivHandler,
                           char *nomPortImprimante, int mode);
extern PROCEDURE Trace(int niveau, ...);


/*== Variables globales importees ============================================*/


/*== Variables globales exportees ============================================*/

extern char  _Fich_[LG_FICHIER+1];  /* Nom du fichier emetteur                */
extern int  _Ligne_;                /* Ligne d'appel dans le fichier C        */

/*================================= FIN ======================================*/

#endif  /* _BIBTRACE_INCLUDED */


