#include "bingo.h"

/*****************************************************************************/

byte AttrFenPrinc;
menuitem *TabSousMenus;
int IdSousMenuImport;
char nomBD[80];

FONCTION int CopieFicNouvelles(void);
FONCTION int CopieFicArchivesMsg(void);

DATAS external_errors[] =
{
   /* Erreurs communes */
/*   { ID_ERR_PASSE,     "Mot de passe incorrect"},*/
   { ID_ERR_IMPR,      "Problme imprimante"},
   { ID_ERR_FIC,       "Problme fichier"},
/*   { ID_ERR_BREV,      "Trop de brevets !"},*/
   { 0,                "" }    /* Fin */
};

/* Nom du repertoire courant */
char RepCourant[LG_PATH+1];

/* Nom du repertoire des donnes */
char RepDonnees[LG_PATH+1];

/* Nom des fichiers eleves et brevets */
char FicEleves[LG_FIC_EXT+1];
char FicBrevets[LG_FIC_EXT+1];
char FicCategorie[LG_FIC_EXT+1];

/* tableau mmorisant les donnes des enfants */
T_ELEVE TabEleves[NB_MAX_ELEVES];

/* tableau mmorisant les brevets */
T_BREVET TabBrevets[NB_MAX_BREVETS+1];

int brevetsClasses[NB_MAX_BREVETS+1];
int brevDejaAff[NB_MAX_BREVETS+1];
int valBrevet[NB_MAX_BREVETS+1];

/* tableau mmorisant l'affichage "(couleur*1000) + idBrevet" */
int TabAffich[80+1][25+1];

/* nombre exact de brevets */
int NbBrevets;

/* nombre de brevets dans l'arbre */
int NbBrevetsDansArbre;

/* nombre exact de categorie */
int NbCategorie;

/* nombre des russites de la classe */
int NbReussites;

/* nombre exact d'lves */
int NbEleves;

/* Plan de travail */
int PT[NB_MAX_ITEM_PT*NB_MAX_ELEVES+1];

/* rglage de l'arbre */
int LongueurBranche=7;            /* 3  9 */ /* ne figure plus dans 'Options' */
int LargeurTronc=-1;              /* initialis lors de l'ouverture de la base */

/* couleurs */

int Couleur0=62;   /* couleur cran arbre */                 /* jaune */
int Couleur1=55;   /* couleur cran blason */                /* jaune clair */
int Couleur2=1;    /* catgorie 15 & criture */              /* bleu */
int Couleur3=3;    /* catgorie 14 & fond titre/slection */  /* turquoise */
int Couleur4=11;   /* catgorie 13 & fond choice */           /* bleu */
int Couleur5=27;   /* catgorie 12 & fond fentre+cr.surbr *//* bleu clair */
int Couleur6=52;   /* catgorie 11 & couleur du curseur pourle blason */
int Couleur7=4;   /* catgorie 10 & couleur du curseur pour la classe */
int Couleur8=10;
int Couleur9=22;
int Couleur10=34;
int Couleur11=18;
int Couleur12=54;
int Couleur13=36;
int Couleur14=52;
int Couleur15=23;

/* mot de passe INSTIT */
char Passe[LG_MOT_PASSE+1];
/* nom de l'instit */
char FicInstit[LG_FIC+1];
char User[LG_USER+1];
char NomResp[LG_USER+1];

/* Modes de fonctionnement */
int  Mode;   /* AVEC ou SANS catgorie */
int  TypeAcces; /* ACCES_INSTIT, ACCES_NON_INIT ou indice de l'lve*/
int  AcceptImport;
int  Ordre;

int LanceMenu=FAUX;

int param=FAUX;

PROCEDURE Verif(int idBrevet)
debut
  SI idBrevet>NB_MAX_BREVETS ALORS
     _winprintf("STOP %d",idBrevet);
     getche();
  FIN_SI
fin


/*****************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : Handler                                     */
/*****************************************************************************/
/* BUT : fonction gerant les Handler des  bibliotheques                      */
/*****************************************************************************/
PROCEDURE Handler(char *libelle, int numero)
debut
  printf("%s : %d",libelle,numero);
fin



/*****************************************************************************/
/* DESCRIPTION DE LA PROCEDURE : About                                       */
/*****************************************************************************/
PROCEDURE far About()
debut
   windows *W_about;
   #define PUB "Rekikmrb0Owbnbp=c`/i{lp+ho"
   char pub[30];
   int i;

   COPIER(pub,PUB);
   i=0;
   TANTQUE pub[i]!='\0' FAIRE
     SI i%2==0 ALORS
        pub[i]=pub[i]-2;
     SINON
        pub[i]=pub[i]+3;
     FIN_SI
     i++;
   FIN_TANTQUE

   W_about = _wincreate(20,6,35,15,SIMPLE,ATTRNORMAL,ATTRNORMAL,"A propos de BINGO",ATTRTITLE);
   _winselect(W_about);

   /* affichage */
   _wingotoxy(12,2);_winputs("BINGO 2009");
   _wingotoxy(5,3);_winprintf("Les Arbres de Connaissance");
   _wingotoxy(7,5);_winprintf("Logiciel gratuit - %s",VERSION);
   _wingotoxy(5,7);_winputs("Freeware");
   _wingotoxy(5,10);_winprintf("%s",pub);

   _getadd_button (15,12,"  ^OK  ",'O',ON,HIGH,0,"");
   _getread (NORMAL_MODE);

   /* effacement et fermeture fentre */
   _windispose(W_about);
}

/*------------------------------------------*/
FONCTION int CopieFicNouvelles()
debut
   FILE* fSrc;
   FILE* fDest;
   char buffer[512];
   int NbLu;
   char source[255], destination[255];

   COPIER(source,"\\");

   L_REPDONNEES(source);
   strcat(source,"\\");
   strcat(source,FIC_NOUVELLES);

   L_REPCOURANT(destination);
   strcat(destination,"\\");
   strcat(destination,FIC_NOUVELLES);

   if((fSrc=fopen(source, "rb")) == NULL)
   {
      return -1;
   }

   if((fDest=fopen(destination, "wb")) == NULL)
   {
      fclose(fSrc);
      return -2;
   }

   while((NbLu=fread(buffer, 1, 512, fSrc)) != 0)
   {
      fwrite(buffer, 1, NbLu, fDest);
   }

   fclose(fDest);
   fclose(fSrc);
   return 0;
fin

/*------------------------------------------*/
FONCTION int CopieFicArchivesMsg()
debut
   FILE* fSrc;
   FILE* fDest;
   char buffer[512];
   int NbLu;
   char source[255], destination[255];

   COPIER(source,"\\");

   L_REPDONNEES(source);
   strcat(source,"\\");
   strcat(source,"\\msg\\");
   strcat(source,FIC_ARCHIVEMSG);

   L_REPCOURANT(destination);
   strcat(destination,"\\");
   strcat(destination,FIC_ARCHIVEMSG);

   if((fSrc=fopen(source, "rb")) == NULL)
   {
      return -1;
   }

   if((fDest=fopen(destination, "wb")) == NULL)
   {
      fclose(fSrc);
      return -2;
   }

   while((NbLu=fread(buffer, 1, 512, fSrc)) != 0)
   {
      fwrite(buffer, 1, NbLu, fDest);
   }

   fclose(fDest);
   fclose(fSrc);
   return 0;
fin


/*------------------------------------------*/

PROCEDURE far Quitter()
debut
  char nomRep[LG_PATH+1];

  /* Copier le fichier des dernires russites */
  CopieFicNouvelles();

  /* Copier le fichier des archives des messages */
  CopieFicArchivesMsg();

  /* Restitution du repertoire courant */
  L_REPCOURANT(nomRep);
  chdir(nomRep);
  _tdirestorepalette();
  _tdiclose();
  window(1,1,80,25);
  clrscr();
  exit(1);
fin

/*------------------------------------------*/

FONCTION int InitBingo(void)
debut
  int i;
  char nomRep[LG_PATH+1];
  char repertoire[LG_PATH+1];

  /* Sauvegarde du repertoire courant */
  getcurdir(0,repertoire);
  strcpy(nomRep,"\\");
  strcat(nomRep,repertoire);
  E_REPCOURANT(nomRep);

  /* Initialisation de l'interface */
  SI InitInterface()==FAUX ALORS
     printf("Un moniteur couleur est ncessaire");
     retour FAUX;
  FIN_SI

  /* Initialisation de l'affichage */
  InitAffichage();

  /* Ouverture du fichier d'aide */
  _helpinit(ATTRNORMAL,ATTRBORDER,ATTRTITLE);
  _helpfile(HELP_FILE);

  /* Initialisation des donnees par defaut */
  E_ORDRE(ORDRE_DETENTEURS);
  E_MODECAT(MODE_SANS_CATEGORIE);
  E_ACCEPTIMPORT(IMPORT_NOK);
  E_FICBREVETS("brevets.txt");
  E_FICELEVES("eleves.txt");
  E_FICCATEGORIE("cat.txt");
  E_REPDONNEES(DOSSIER_DEFAUT);
  E_PASSE("PROF");
  E_TYPEACCES(ACCES_NON_INIT);
  E_FIC_INSTIT("instit");
  E_USER("Utilisateur");
  E_RESP("Responsable");

  /* les catgories */
  i=0;
  TANTQUE i<NB_MAX_CATEGORIE FAIRE
     COPIER(Categorie[i].Libelle,LIB_CAT_VIERGE);
     i++;
  FIN_TANTQUE

  /* les niveaux */
  i=0;
  TANTQUE i<NB_MAX_ELEVES FAIRE
     TabEleves[i].BrevElev[0]=NON_INIT;
     i++;
  FIN_TANTQUE

  retour VRAI;
fin



/*****************************************************************************/
/* BUT : Main de BINGO                                                       */
/*****************************************************************************/
PROCEDURE main(int argc, char *argv[])

debut
  int cr;
  char nomresp[LG_USER+1+2];
  char nomuser[LG_USER+1+2];


  AttenteDebut();

  InitBingo();

  /* Prise en compte des paramtres */
  SI argc>1 ALORS
     /* les paramtres /v et /l taient utiliss dans des versions prcdentes */
     SI stricmp(argv[1],"/L")!=0 ET stricmp(argv[1],"/l")!=0
	ET stricmp(argv[1],"/I")!=0 ET stricmp(argv[1],"/i")!=0
	ET stricmp(argv[1],"/v")!=0 ET stricmp(argv[1],"/V")!=0
	ET stricmp(argv[1],"/n")!=0 ET stricmp(argv[1],"/N")!=0	ALORS
	E_REPDONNEES(argv[1]);
	param=VRAI;
     SINON
	SI stricmp(argv[1],"/L")==0 OU stricmp(argv[1],"/l")==0 OU
	   stricmp(argv[1],"/i")==0 OU stricmp(argv[1],"/I")==0 ALORS
	   E_TYPEACCES(ACCES_INSTIT);
	SINON
	   E_TYPEACCES(ACCES_NON_INIT);
	FIN_SI
	SI argc>2 ALORS
	   E_REPDONNEES(argv[2]);
	   param=VRAI;
	FIN_SI
     FIN_SI
  FIN_SI

  /* verification de l'existence du repertoire des donnees */
  cr=OuvertureBase();
  SI cr==FICHIER_ABSENT ET param==VRAI ALORS
     E_REPDONNEES(DOSSIER_DEFAUT);
     cr=OuvertureBase();
  FIN_SI

  LORSQUE cr VAUT
    SOIT FICHIER_ABSENT : Creation();
			  FIN_SOIT
    SOIT FICHIER_ERREUR :  SyntaxeErreur(ID_BD,RepDonnees,0);
			   Quitter(0);
			   FIN_SOIT
  FIN_LORSQUE

  /* cration des menus */
  strcpy(nomuser," "); strcat(nomuser,User); strcat(nomuser," ");
  _menucreate(nomuser,ON,0,_menuunder,1,nomBD);
     _menuline();
     _menucreate ("L'arbre",ON,F10,GestEvts,GEST_ARBRE,"Afficher l'arbre de la classe ou les brevets par catgorie");
     _menuline();
     _menucreate ("Les projets",ON,0,MenuGroupesDeTravail,FAUX,"Voir des groupes possibles  mettre en place");
     _menuline();
     _menucreate("Quitter",ON,CF4,Quitter,0,nomBD);
  _menuend();

  strcpy(nomresp," "); strcat(nomresp,NomResp); strcat(nomresp," ");
  _menucreate (nomresp,ON,ALTE,_menuunder,0,nomBD);
     _menucreate("Les derniers changements",ON,0,Nouvelles,0,"Voir les dernires russites de la classe");
     _menucreate("Les mots de passe",ON,0,VoirMotsDePasse,0,"Voir les mots de passe des lves");
     _menuline();
     _menucreate ("L'arbre",ON,F10,GestEvts,GEST_ARBRE,"Afficher l'arbre de la classe ou les brevets par catgorie");
     _menuline();
     _menucreate("Les projets",ON,0,MenuGroupesDeTravail,FAUX,"Voir des groupes possibles  mettre en place");
     _menucreate("Les blasons",ON,0,VoirBlasonDansArbre,0,"Visualiser tous les blasons dans l'arbre de la classe");
     _menucreate("Les arbustes",ON,0,VoirTousArbres,0,"Visualiser tous les arbres ou graphismes");
     _menucreate("La liste des brevets de chacun",ON,0,AffichTousBlasons,0,"Visualiser tous les blasons");
     _menuline();

     _menucreate ("Crer ou modifier une catgorie",ON,0,ModifCategories,0,"Modifier les noms des catgories");
     _menucreate("Ajouter des lves",ON,0,MenuAjoutEleves,0,"Ajout d'lves");
     _menucreate("Enlever des lves",ON,0,MenuSuppEleves,0,"Enlever des lves");
     _menucreate("Cration de fichiers pour impression",VRAI,0,Sauvegarde,0,"Exportations des listes de brevets et blason");
     _menucreate("Paramtres",ON,0,ModifParam,0,"Modification des paramtres");
     _menuline();
     _menucreate("A propos",ON,0,About,0,"Informations sur le logiciel");
     _menucreate("Quitter",ON,CF4,Quitter,0,nomBD);

  _menuend();

  LanceMenu=FAUX;
  GestEvts(GEST_ARBRE);

  SI LanceMenu==VRAI ALORS
     _menurun();
  FIN_SI

  Quitter(0);
fin
