/***************************************************************************/
/*                          BINGO.H                                        */
/***************************************************************************/
#include <conio.h>
#include <io.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <math.h>
#include <alloc.h>
#include "bibmouse.h"
#include "tdi21.h"
#include "dos.h"

extern PROCEDURE Verif(int idBrevet);

#include "interfnx.h"
#include "gestfnx.h"
#include "specfnx.h"
#include "gestfnx.h"
#include "arbrefnx.h"
#include "brevfnx.h"
#include "codefnx.h"
#include "categfnx.h"
#include "enfanfnx.h"
#include "messfnx.h"

#include <francais.h>

#ifdef TRACE_BINGO
  #include <bibtrace.h>
#endif


/* niveaux de trace */
#define NIV_BREVET      9
#define NIV_DEBUG       10
#define NIV_HANDLER     1

#define LG_LIGNE           256
#define LG_COMMENT         70

/******************************** CONSTANTES *********************************/


#define NON_INIT  -9999

#define VERSION "4.0"
#define MOT_PASSE_DEFAUT "PROF"
#define HELP_FILE "ognib.txt"

/* Arbre */

#define Y_AXETRONC       19
#define X_AXETRONC       39
#define LARGEUR_MAX_TRONC   6   /* la largeur effective est plus grande d'une unit */
#define POURC_MAX_TRONC    100  /* pour rester sur le tronc */
#define POURC_MAX_BRANCHE  100  /* pour rester sur la branche */

/* Origines fentres */

#define X1_AFF_BREVETS           2
#define Y1_AFF_BREVETS           3
#define DX_AFF_BREVETS           77   /* (MULTIPLE DE (SURNOM+1))+3 */
#define DY_AFF_BREVETS           21

#define Y1_AFF_CHEM_CLASS         2
#define DX_AFF_CHEM_CLASS         77
#define DY_AFF_CHEM_CLASS         10

#define Y1_AFF_CHEM_ENF          13
#define DX_AFF_CHEM_ENF          77
#define DY_AFF_CHEM_ENF          10

/* fichiers */
#define DOSSIER_DEFAUT           "DONNEES"
#define NOM_FIC_CONFIG           "config.txt"
#define FIC_NOUVELLES            "nouvelle.txt"
#define FIC_ARCHIVEMSG           "archives.txt"
#define LG_PATH      		  255
#define LG_FIC                   8
#define LG_FIC_EXT              12
#define LG_DOSSIER              7

/* eleve */
#define NB_MAX_ELEVES         35  /* 35 */
#define LG_NOM_ELEVE            15
#define LG_SURNOM_ELEVE         14  /* si chgt modif dans le code */
#define LG_MOT_PASSE            10
#define PERSONNE                 -1
#define PAS_DE_NOM               "\0"

/* brevet */

#define NB_MAX_BREVETS       500    /* 700 : unsigned char dans struct ELEVE */
				      /* limite  1000 par le fonctionnement */

#define NB_MAX_BREV_ELEV    100  /* 300 : nb maximum de brevet d'un eleve */
#define LG_TITRE_BREVET         60
#define PAS_DE_BREVET            -999
#define EFFACE_BREVET "                    "
#define A_REPASSER              -1    /* Ne pas changer cette valeur */
#define REUSSI                  +1    /* Idem */
#define A_ENLEVER                2
#define LG_RECHERCHE            15    /* longueur de la chaine de recherche */

/* Plan de travail */
#define NB_MAX_ITEM_PT   3
#define NB_PROPOSITIONS  3

/* categorie */
#define NB_MAX_CATEGORIE         14
#define AUCUNE_CATEGORIE         -1
#define LG_CATEGORIE             14   /* LectureFicCat dans Spec */
#define LIB_CAT_VIERGE          "              "

/* objectifs */
/* #define AUCUN_OBJECTIF            0
#define AFFICH                    0
#define IMPRIM                    1   */

/* Niveaux */
/*#define NB_MAX_NIVEAUX            10 */

/* Auteur */
#define AUCUN_AUTEUR        -99

/* Les fichiers */
#define CONV12                   12
#define CONV20                   20
#define FICHIER_ERREUR            1
#define FICHIER_OUVERT            2
#define FICHIER_ABSENT            3

/* les diffrents modes */
#define MODE_CATEGORIE            1
#define MODE_SANS_CATEGORIE       2
#define IMPORT_OK                 1
#define IMPORT_NOK                0
#define ORDRE_CHRONO              1
#define ORDRE_DETENTEURS          2

/* les diffrents types d'accs */
#define ACCES_NON_INIT      -1
#define ACCES_INSTIT        -1000

/* Diverses constantes */

#define GEST_TOUS                -2    /* obligatoirement ngatif */
#define GEST_ARBRE               -1
#define GEST_TOUS_ARBRE          -3
#define NOUVEAU                   1
#define MODIFIER                  2

/* Les messages */
#define LG_MESSAGE   74

#define LG_USER      20

/* ------------------------  attributs  --------------------------------- */

#define GRAPH_BREVET    22
#define GRAPH_BLASON    23
#define GRAPH_PT_CLASSE 24
#define GRAPH_PT_ENFANT 25
#define GRAPH_RECHERCHE 26

#define COULEUR0 0
#define COULEUR1 1
#define COULEUR2 2
#define COULEUR3 3
#define COULEUR4 4
#define COULEUR5 5
#define COULEUR6 6
#define COULEUR7 7
#define COULEUR8 8
#define COULEUR9 9
#define COULEUR10 10
#define COULEUR11 11
#define COULEUR12  12
#define COULEUR13  13
#define COULEUR14  14
#define COULEUR15  15

#define CLIGNOTE        128

#define         ATTRARBRE      (COULEUR0<<4)+COULEUR2
#define         ATTRBLASON     (COULEUR1<<4)+COULEUR2

#define         ATTRMENU       (COULEUR5<<4)+COULEUR2
#define         ATTRBARRE      (COULEUR5<<4)+COULEUR2

#define         ATTRNORMAL      (COULEUR5<<4)+COULEUR2     /* fenetre */
#define         ATTRTITLE       (COULEUR3<<4)+COULEUR1
#define         ATTRDEACTIVED   (COULEUR3<<4)+COULEUR1

#define         ATTRSELECT      (COULEUR3<<4)+COULEUR0
#define         ATTRDISCRET     (COULEUR5<<4)+COULEUR3
#define         ATTRCHOICE      (COULEUR5<<4)+COULEUR2
#define         ATTRCHOICE2     (COULEUR3<<4)+COULEUR0
#define         ATTRERREUR      (COULEUR2<<4)+COULEUR0

#define         ATTRBORDER      ATTRNORMAL
#define         ATTRKEY         ATTRNORMAL
#define         ATTRCOMMENT     ATTRNORMAL
#define         ATTRUNSELECT    ATTRNORMAL
#define         ATTROMBRE       ATTRNORMAL
#define         ATTRMESSAGE     ATTRNORMAL
#define         ATTRGET         ATTRSELECT


/* -------------- erreurs pour fonction errdisplay (TDI) ------------------ */
/*#define ID_ERR_PASSE   1 */
#define ID_ERR_IMPR    2
#define ID_ERR_FIC     3
/*#define ID_ERR_BREV    4*/

/* message d'erreurs */

#define       ID_SEREP                  0 /* repertoire */
#define       ID_SENE                   1 /* nom de l'lve */
#define       ID_SEPE                   2 /* prenom de l'lve */
#define       ID_SESE                   3 /* surnom de l'lve */
#define       ID_SEPS                   4 /* mot de passe */
#define       ID_SEFE                   5 /* nom de fichier incorrect */
#define       ID_SELIB                  6 /* libelle incorrect */
#define       ID_SENBR                  7 /* id ou nb de brevet incorrect */
#define       Id_IMP                    8 /* erreur imprimante */
#define       ID_CODE                   9 /* erreur dans le code */
#define       ID_BD                    10 /* erreur ouverture base de donnes */

/********************************   TYPES   **********************************/

/* dfinition du type INTERVALLE */
typedef struct {
    int Inf;
    int Sup;
} T_INTERV;

typedef struct {
   char PrenomEleve[LG_NOM_ELEVE+1];
   char NomEleve[LG_NOM_ELEVE+1];
   char Surnom[LG_SURNOM_ELEVE+1];
   char NomFic[LG_FIC_EXT+1];
   char MotPasse[LG_MOT_PASSE+1];
   int far BrevElev[NB_MAX_BREV_ELEV+1]; /* indice commence  1 et non  0 */
   unsigned int NbBrevetsElev;
} T_ELEVE;


typedef struct {
    int NbDetenteurs; /* nombre de detenteur du brevets */
    int IdCategorie;
    int IdAuteur;
} T_BREVET  ;


typedef struct {
    char Libelle[LG_CATEGORIE+1];
    int  Id;
} T_LIBID;


/********************************   VARIABLES   **********************************/

extern byte AttrFenPrinc;
extern menuitem *TabSousMenus;
extern int IdSousMenuImport;
extern char nomBD[80];

extern T_LIBID Categorie[NB_MAX_CATEGORIE];

/* Nom du repertoire courant */
extern char RepCourant[LG_PATH+1];

/* Nom du repertoire des championnats */
extern char RepDonnees[LG_PATH+1];

/* Nom des fichiers eleves et brevets */
extern char FicEleves[LG_FIC_EXT+1];
extern char FicBrevets[LG_FIC_EXT+1];
extern char FicCategorie[LG_FIC_EXT+1];

/* tableau mmorisant les donnes des enfants */
extern T_ELEVE TabEleves[];

/* tableau mmorisant les brevets */
extern T_BREVET TabBrevets[NB_MAX_BREVETS+1];  /* indice commence  1 */
extern int brevetsClasses[NB_MAX_BREVETS+1];
extern int brevDejaAff[NB_MAX_BREVETS+1];
extern int valBrevet[NB_MAX_BREVETS+1];

/* tableau mmorisant l'affichage */
extern int TabAffich[80+1][25+1];

/* nombre exact de brevets */
extern int NbBrevets;

/* nombre de brevets dans l'arbre */
extern int NbBrevetsDansArbre;

/* nombre exact de categorie */
extern int NbCategorie;

/* nombre exact d'lves */
extern int NbEleves;

/* plan de travail*/
extern int PT[];

/* nombre de russites de la classe */
extern int NbReussites;

/* rglage de l'arbre */
extern int LongueurBranche;
extern int LargeurTronc;

/* couleurs */
extern int Couleur0;
extern int Couleur1;
extern int Couleur2;
extern int Couleur3;
extern int Couleur4;
extern int Couleur5;
extern int Couleur6;
extern int Couleur7;
extern int Couleur8;
extern int Couleur9;
extern int Couleur10;
extern int Couleur11;
extern int Couleur12;
extern int Couleur13;
extern int Couleur14;
extern int Couleur15;


/* mot de passe gnral */
extern char Passe[LG_MOT_PASSE+1];
/* nom de l'instit */
extern char FicInstit[LG_FIC+1];

extern char User[LG_USER+1];
extern char NomResp[LG_USER+1];

/* Modes de fonctionnement */
extern int  Mode;
extern int  Ordre;
extern int  AcceptImport;
extern int  TypeAcces;

extern int LanceMenu;

/********************************   MACROS **********************************/

#define   L_REPCOURANT(nom)             COPIER_N(nom,RepCourant,LG_PATH)
#define   L_FICELEVES(nom)              COPIER_N(nom,FicEleves,LG_FIC_EXT)
#define   L_FICBREVETS(nom)             COPIER_N(nom,FicBrevets,LG_FIC_EXT)
#define   L_FICCATEGORIE(nom)           COPIER_N(nom,FicCategorie,LG_FIC_EXT)
#define   L_REPDONNEES(nom)             COPIER_N(nom,RepDonnees,LG_PATH)
#define   L_PRENOMELEVE(idEleve)        TabEleves[idEleve].PrenomEleve
#define   L_NOMELEVE(idEleve)           TabEleves[idEleve].NomEleve
#define   L_ECHANGE(idEleve)            TabEleves[idEleve].Echange
#define   L_SURNOMELEVE(idEleve)       TabEleves[(idEleve)].Surnom
#define   L_NBDETENTEURS(idBrevet)      TabBrevets[idBrevet].NbDetenteurs
#define   L_NBBREVETSDANSARBRE()        NbBrevetsDansArbre
#define   L_NBCATEGORIE()               NbCategorie
#define   L_MOTDEPASSEBREVET(idBrevet)  TabBrevets[idBrevet].MotDePasseBrevet
#define   L_IDCATEGORIE(idBrevet)       TabBrevets[idBrevet].IdCategorie
#define   L_IDAUTEUR(idBrevet)          TabBrevets[idBrevet].IdAuteur
#define   L_NIVEAUBREVET(idBrevet)      TabBrevets[idBrevet].Niveau
#define   L_NOMFIC(idEleve)             TabEleves[idEleve].NomFic
#define   L_MOTPASSE(idEleve)           TabEleves[idEleve].MotPasse
#define   L_NBBREVETSELEV(idEleve)      TabEleves[idEleve].NbBrevetsElev
#define   L_BREVELEV(idEleve,id)        (TabEleves[idEleve].BrevElev[id])%(1000)
#define   L_NBREUSSITES()               NbReussites
#define   L_BREVELEVMOIS(idEleve,id)    (TabEleves[idEleve].BrevElev[id])/(1000)
#define   L_NIVEAUELEVE(idEleve)        TabEleves[idEleve].Niveau
#define   L_PASSE()                     Passe
#define   L_FIC_INSTIT()                FicInstit
#define   L_USER()                      User
#define   L_RESP()                      NomResp
#define   L_TABAFFICH(x,y)              TabAffich[x][y]
#define   L_NBELEVES()                  NbEleves
#define   L_NBBREVETS()                 NbBrevets
#define   L_MODECAT()                   Mode
#define   L_ORDRE()                     Ordre
#define   L_TYPEACCES()                 TypeAcces

#define   E_REPCOURANT(nom)             COPIER_N(RepCourant,nom,LG_PATH)
#define   E_FICELEVES(nom)              COPIER_N(FicEleves,nom,LG_FIC_EXT)
#define   E_FICBREVETS(nom)             COPIER_N(FicBrevets,nom,LG_FIC_EXT)
#define   E_FICCATEGORIE(nom)           COPIER_N(FicCategorie,nom,LG_FIC_EXT)
#define   E_REPDONNEES(nom)             COPIER_N(RepDonnees,nom,LG_PATH)
#define   E_PRENOMELEVE(idEleve,nom)    strcpy(TabEleves[idEleve].PrenomEleve,nom)
#define   E_NOMELEVE(idEleve,nom)       strcpy(TabEleves[idEleve].NomEleve,nom)
#define   E_SURNOMELEVE(idEleve,nom)    strcpy(TabEleves[(idEleve)].Surnom,nom)
#define   E_NBDETENTEURS(idBrevet,nb)   Verif(idBrevet);TabBrevets[idBrevet].NbDetenteurs=nb
#define   E_NBBREVETSDANSARBRE(nb)      NbBrevetsDansArbre=nb
#define   E_NBCATEGORIE(nb)             NbCategorie=nb
#define   E_NIVEAUBREVET(idBrevet,niveau) Verif(idBrevet);TabBrevets[idBrevet].Niveau=niveau
#define   E_MOTDEPASSEBREVET(idBrevet,motPasse) Verif(idBrevet);strcpy(TabBrevets[idBrevet].MotDePasseBrevet,motPasse)
#define   E_IDCATEGORIE(idBrevet,id)    Verif(idBrevet);TabBrevets[idBrevet].IdCategorie=id
#define   E_IDAUTEUR(idBrevet,id)       Verif(idBrevet);TabBrevets[idBrevet].IdAuteur=id
#define   E_NOMFIC(idEleve,nom)         strcpy(TabEleves[idEleve].NomFic,nom)
#define   E_MOTPASSE(idEleve,nom)       strcpy(TabEleves[idEleve].MotPasse,nom)
#define   E_NBBREVETSELEV(idEleve,nbBrev) TabEleves[idEleve].NbBrevetsElev=nbBrev
#define   E_BREVELEV(idEleve,id,numBrevMois) TabEleves[idEleve].BrevElev[id]=numBrevMois
#define   E_NBREUSSITES(nb)             NbReussites=nb
#define   E_NIVEAUELEVE(idEleve,niveau)  TabEleves[idEleve].Niveau=niveau
#define   E_PASSE(nom)                  strcpy(Passe,nom)
#define   E_FIC_INSTIT(nom)             strcpy(FicInstit,nom)
#define   E_USER(nom)                   strcpy(User,nom)
#define   E_RESP(nom)                   strcpy(NomResp,nom)
#define   E_TABAFFICH(x,y,idBrevet)     TabAffich[x][y]=idBrevet
#define   E_NBELEVES(nbElev)            NbEleves=nbElev
#define   E_NBBREVETS(nbBrev)           NbBrevets=nbBrev
#define   E_MODEINSTIT(modInstit)       Instit=modInstit
#define   E_MODECAT(modCat)             Mode=modCat
#define   E_ORDRE(ordre)                Ordre=ordre
#define   E_ACCEPTIMPORT(d)             EAcceptImport((d))
#define   E_TYPEACCES(acces)            TypeAcces=acces

/************************ FONCTION DU FICHIER BINGO.C ******************/
extern PROCEDURE far Quitter(int clef);
