/*****************************************************************************/
/*                                                                           */
/* DESCRIPTION DE L'UCS (UNITE COMPILABLE SEPAREMENT) : INTER.C              */
/*                                                                           */
/*****************************************************************************/
#include "bingo.h"

/*****************************************************************************/

/*****************************************************************************/
/*                              CONSTANTES                                   */
/*****************************************************************************/

/* longueur max des messages Syntaxe Erreur */
#define  LG_MSG                     400

/*****************************************************************************/
/*                          VARIABLES STATIQUES                              */
/*****************************************************************************/

#define NB_SYNTAXE_ERREUR       11

static char TabSyntaxeErreur[NB_SYNTAXE_ERREUR][LG_MSG]={
     "Rpertoire incorrect",
     "Nom d'lve incorrect",
     "Prnom d'lve incorrect",
     "Surnom d'lve incorrect",
     "Mot de passe d'lve incorrect",
     "Nom de fichier incorrect",
     "Libell incorrect",
     "Id ou nb. de brevet incorrect",
     "Problme imprimante",
     "Probleme dans une fonction",
     "Problme base de donnes"
};

/*****************************************************************************/
/*                          CONSTANTES STATIQUES                             */
/*****************************************************************************/
#define SPEC_Y1    1
#define SPEC_Y2   12

#define STATG_Y1      13
#define STATG_Y2      15
#define STATG_COLOR_B BLUE
#define STATG_COLOR_T YELLOW

#define STAT_Y1       16
#define STAT_Y2       25
#define STAT_COLOR_B  MAGENTA
#define STAT_COLOR_T  WHITE

PROCEDURE AffichDate(char *chDate)
debut
  struct date dat;
  struct time tim;

  char mois[12][10]={"Janvier","Fvrier","Mars","Avril","Mai","Juin",
	     "Juillet","Aot","Septembre","Octobre","Novembre","Dcembre"};

  getdate(&dat);
  gettime(&tim);

  sprintf(chDate,"  %d %s %d  %d:%02d",dat.da_day,mois[dat.da_mon-1],dat.da_year,
  tim.ti_hour,tim.ti_min);

fin

PROCEDURE AffichDate2(char *chDate)
debut
  struct date dat;
  struct time tim;

  getdate(&dat);
  gettime(&tim);

  sprintf(chDate,"%d-%d %d:%02d",dat.da_day,dat.da_mon,tim.ti_hour,tim.ti_min);

fin

/*---------------------------------------------------*/

PROCEDURE Message(int hauteurFen,int attribut, int idEnfant, char *format,...)
debut
  va_list pArgument;
  char    msg[LG_MSG+1];
  windows *W_mess;
  char surnom[LG_SURNOM_ELEVE+1];
  char titre[LG_MESSAGE];

  va_start(pArgument,format);
  vsprintf(msg,format,pArgument);
  va_end(pArgument);

  SI idEnfant>=0 ALORS

     COPIER(surnom,L_SURNOMELEVE(idEnfant));
     SI strupr(surnom)[0]=='E' OU strupr(surnom)[0]=='I' OU
        strupr(surnom)[0]=='U' OU strupr(surnom)[0]=='A' OU
        strupr(surnom)[0]=='O' OU strupr(surnom)[0]=='Y' ALORS
        sprintf(titre,"Blason d'%s",surnom);
     SINON
        sprintf(titre,"Blason de %s",surnom);
     FIN_SI
  SINON
     sprintf(titre,"Message de BINGO");
  FIN_SI

  W_mess = _wincreate((80-LG_MESSAGE)/2,4,LG_MESSAGE,hauteurFen,SIMPLE,ATTRNORMAL,
		       ATTRNORMAL,titre,attribut);
  _winselect(W_mess);

  /* affichage */
  _winputs(msg);

  _getadd_button ((LG_MESSAGE-3)/2,hauteurFen-3," ^OK ",'O',ON,HIGH,0,"");

  _getread (NORMAL_MODE);

   /* effacement et fermeture fentre */
   _windispose(W_mess);

fin


/*---------------------------------------------------*/
PROCEDURE PaletteBingo(void)
/* li aux constantes dans BINGO.H */
debut
      _tdipalette (0,Couleur0);
      _tdipalette (1,Couleur1);
      _tdipalette (2,Couleur2);
      _tdipalette (3,Couleur3);
      _tdipalette (4,Couleur4);
      _tdipalette (5,Couleur5);
      _tdipalette (6,Couleur6);
      _tdipalette (7,Couleur7);

      _tdipalette (8,Couleur8);
      _tdipalette (9,Couleur9);
      _tdipalette (10,Couleur10);
      _tdipalette (11,Couleur11);

      _tdipalette(12,Couleur12);
      _tdipalette(13,Couleur13);
      _tdipalette(14,Couleur14);
      _tdipalette(15,Couleur15);
fin

/*---------------------------------------------------*/

FONCTION int InitInterface()
debut
  static byte carVGABrevet[]={0,127,127,127,127,127,127,127,
                           127,127,127,127,127,127,127,0};
  static byte car2VGABrevet[]={0,127,127,65,65,65,65,65,
			   65,65,65,65,65,127,127,0};
  static byte car3VGABrevet[]={0,127,127,65,65,93,93,93,
			   93,93,93,65,65,127,127,0};
  static byte car4VGABrevet[]={0,127,127,65,65,93,93,85,
			   85,93,93,65,65,127,127,0};
  static byte car5VGABrevet[]={0,127,127,127,127,107,107,119,
			   119,107,107,127,127,127,127,0};

/*			      *******    ********   H G F 8 4 2 1
			      *******    *      *   * * * * * * *  1
			      *******    *      *   *   *   *   *  2
			      *******    *   *  *   * *   *   * *  3
			      *******    *      *   *   *   *   *  4
			      *******    *      *   * *   *   * *  5
			      *******    ********   *   *   *   *  6
						    * *   *   * *  7
........	........ 0	........   0		    *   *   *   *  8
.*****.*189	.******* 127	.**..**.   64+32+4+2=102			    *           *  9
.*****.*189     .******* 127	...**...   64+16+4=24					*  10
**.**.**219           ** 127    .**.*.*.   64+32+8+2
**.**.**219       **..** 115    .*.*.*..   64+16+4
***..***        .*******        .**.*.*.
**.**.**	.*******        .*.*.*..
*.***..*	.*******        .**.*.*.
........	........	........					*   13
						    * * * * * * *  14*/
  _tdiinit();
  _tdichangefont(GRAPH_BREVET,carVGABrevet);
  _tdichangefont(GRAPH_BLASON,car2VGABrevet);
  _tdichangefont(GRAPH_PT_CLASSE,car3VGABrevet);
  _tdichangefont(GRAPH_PT_ENFANT,car4VGABrevet);
  _tdichangefont(GRAPH_RECHERCHE,car5VGABrevet);

  SI _tdidisplaytype()!=SCREEN_MONO ALORS
      PaletteBingo();

      _wininit(ATTRARBRE,ATTRBORDER);
      _helpbarinit(ATTRNORMAL,ATTRBORDER);
      /* normal, key, comment, active, dsactiv */
      _menuinit(ATTRNORMAL,ATTRKEY,ATTRCOMMENT,ATTRSELECT,ATTRDEACTIVED);
      _buttinit(ATTRNORMAL,ATTRKEY,ATTRSELECT,ATTRUNSELECT,ATTROMBRE);
      _errinit(ATTRNORMAL,ATTRBORDER,ATTRERREUR,ATTRMESSAGE);
      _helpinit(ATTRNORMAL,ATTRBORDER,ATTRTITLE);

      _getinit(ATTRSELECT,ATTRTITLE);
      _choiceinit(ATTRCHOICE,ATTRCHOICE2,ATTRNORMAL);

      /* La souris */

      InitSouris();
      AllumeCurseurSouris();

   SINON
     retour FAUX;
   FIN_SI

   retour VRAI;
fin

/*---------------------------------------------------*/

PROCEDURE Centrer(char *entree, char *sortie, int longueur)
debut
  int i;
  int long_entree,nbEspaces;
  char copieEntree[80+1];

  COPIER_N(copieEntree,entree,longueur);
  long_entree=strlen(entree);
  nbEspaces=(longueur-long_entree)/2;

  i=0;
  TANTQUE i<nbEspaces FAIRE
     sortie[i]=' ';
     i++;
  FIN_TANTQUE
  sortie[i]='\0';
  strcat(sortie,copieEntree);
fin

/*---------------------------------------------------*/

FONCTION char * SuppEspaceFin(char *nom)
debut
  int i;

  /* suppression des espaces avant */
  TANTQUE *nom==' ' FAIRE
     nom=nom+sizeof(char);
  FIN_TANTQUE

  /* suppression des espaces apres */
  i=strlen(nom);
  TANTQUE i>0 ET nom[i-1]==' ' FAIRE
     i--;
  FIN_TANTQUE

  nom[i]='\0';

  retour nom;
fin

/*---------------------------------------------------*/
PROCEDURE SuppAccent(char *nom)
debut
  int i;

  i=0;
  TANTQUE nom[i]!='\0' FAIRE
      LORSQUE nom[i] VAUT
	 SOIT '':nom[i]='e';
		  FIN_SOIT
	 SOIT '':nom[i]='e';
		  FIN_SOIT
      FIN_LORSQUE
      i++;
  FIN_TANTQUE
fin


/*---------------------------------------------------*/

FONCTION char * ArretEspace(char *nom)
debut
  int i;

  /* suppression des espaces avant */
  TANTQUE *nom==' ' FAIRE
     nom=nom+sizeof(char);
  FIN_TANTQUE

  /* arret de la copie au premier espace */
  i=0;
  TANTQUE i<strlen(nom) ET nom[i]!=' ' FAIRE
     i++;
  FIN_TANTQUE

  nom[i]='\0';

  retour nom;
fin

/*---------------------------------------------------*/

PROCEDURE AffichBandeau()
debut
  char repertoire[LG_PATH+1];
  char identifiant[80];

  COPIER(identifiant,"");
  L_REPDONNEES(repertoire);
  SI chdir(repertoire)==0 ALORS
     sprintf(nomBD,"%s (%d enfants - %d brevets)",repertoire,L_NBELEVES(),L_NBBREVETS());
     SI L_TYPEACCES()==ACCES_INSTIT ALORS
	sprintf(identifiant," => Responsable");
     SINON
	SI L_TYPEACCES()!=ACCES_NON_INIT ALORS
	   sprintf(identifiant," => %s %s",L_PRENOMELEVE(L_TYPEACCES()),L_NOMELEVE(L_TYPEACCES()));
	FIN_SI
     FIN_SI
     strcat(nomBD,identifiant);
     L_REPCOURANT(repertoire);
     chdir(repertoire);
  SINON
     COPIER(nomBD,"AUCUNE BASE DE DONNEES OUVERTE");
  FIN_SI

fin

/*---------------------------------------------------*/
PROCEDURE AffichInfoBrevet(int idBrevet, int idEnfant)
debut
  char nomBarreBrev[78+1];
  int attrib,catBrev;
  char titre[80];
  char titreBrevet[LG_TITRE_BREVET+1];
  char comment1[LG_LIGNE+1];
  char comment2[LG_LIGNE+1];

  SI idEnfant>=0 ALORS
     attrib=(COULEUR1<<4)+COULEUR2;
  SINON
     attrib=(COULEUR0<<4)+COULEUR2;
  FIN_SI

  gotoxy(1,23);textattr(attrib);clreol();

  SI idBrevet!=PAS_DE_BREVET ALORS
     /* Affichage du nom du brevet */
     comment2[0]='\0';
     comment1[0]='\0';
     titreBrevet[0]='\0';

     LitInfosBrevet(idBrevet,titreBrevet,comment1,comment2);

     catBrev=L_IDCATEGORIE(idBrevet);
     SI catBrev!=AUCUNE_CATEGORIE ALORS
	sprintf(titre,"%s => %s",titreBrevet,Categorie[catBrev].Libelle);
     SINON
	sprintf(titre,"%s",titreBrevet);
     FIN_SI

     Centrer(titre,nomBarreBrev,78);
     gotoxy(1,23); puts(nomBarreBrev);
  FIN_SI
fin

/*---------------------------------------------------*/

PROCEDURE AffichBrevet(int x, int y, int idEnfant, int idBrevet, int coulCat, int couleur)
debut
  int car=GRAPH_BREVET;
  int catBrev;

   SI coulCat==VRAI ALORS
      catBrev=L_IDCATEGORIE(idBrevet);
      LORSQUE catBrev VAUT
	SOIT 0 :
	SOIT -1 :couleur=COULEUR15;FIN_SOIT
	SOIT 1 : couleur=COULEUR14;FIN_SOIT
	SOIT 2 : couleur=COULEUR13;FIN_SOIT
	SOIT 3 : couleur=COULEUR12;FIN_SOIT
	SOIT 4 : couleur=COULEUR11;FIN_SOIT
	SOIT 5 : couleur=COULEUR10;FIN_SOIT
	SOIT 6 : couleur=COULEUR9;FIN_SOIT
	SOIT 7 : couleur=COULEUR8;FIN_SOIT
	SOIT 8 : couleur=COULEUR7;FIN_SOIT
	SOIT 9 : couleur=COULEUR6;FIN_SOIT
	SOIT 10 : couleur=COULEUR5;FIN_SOIT
	SOIT 11 : couleur=COULEUR4;FIN_SOIT
	SOIT 12 : couleur=COULEUR3;FIN_SOIT
	SOIT 13 : couleur=COULEUR2;FIN_SOIT

      FIN_LORSQUE
  FIN_SI

  SI L_NBDETENTEURS(idBrevet)==0 ALORS
     couleur=COULEUR0;
  FIN_SI

  SI BrevetEstDansPT(idBrevet) ALORS
     car=GRAPH_PT_CLASSE;
  FIN_SI


  SI y>1 ALORS
     _wingotoxy(x,y);
     SI idEnfant>=0 ALORS
	SI EnfantABrevet(idEnfant,idBrevet)==1 ALORS
	   car=GRAPH_BLASON;
	FIN_SI
     FIN_SI

     _winattr((COULEUR2<<4)+couleur);
     _winputc(car);
     _winattr(AttrFenPrinc);
     E_TABAFFICH(x+1,y+2,(couleur*1000)+idBrevet);
  FIN_SI

fin

/*---------------------------------------------------*/

PROCEDURE SyntaxeErreur(int IdErreur,char *nomFic, int NumLigne)
debut
  windows *W_mess;
  char msg[80];

  W_mess = _wincreate((80-LG_MESSAGE)/2,7,LG_MESSAGE,13,SIMPLE,ATTRNORMAL,
		       ATTRNORMAL,"SYNTAXE ERREUR",ATTRERREUR);
  _winselect(W_mess);

  sprintf(msg,"\n\nErreur (fichier %s) ligne %d : %s\n",nomFic,NumLigne,TabSyntaxeErreur[IdErreur]);

  _winputs(msg);

  _getadd_button ((LG_MESSAGE-3)/2,10," ^OK ",'O',ON,HIGH,0,"");
  _getread (NORMAL_MODE);

   /* effacement et fermeture fentre */
   _windispose(W_mess);



  printf("\n\nErreur (fichier %s) ligne %d : %s\n",nomFic,NumLigne,TabSyntaxeErreur[IdErreur]);
fin

/*---------------------------------------------------*/

PROCEDURE InitAffichage()
debut
  int i,j;
  char nomBD[80], nomBDS[80];

  i=0;
  TANTQUE i<=80 FAIRE
     j=0;
     TANTQUE j<=25 FAIRE
        E_TABAFFICH(i,j,PAS_DE_BREVET);
        j++;
     FIN_TANTQUE
     i++;
  FIN_TANTQUE

/*  SI L_ORDRE()==ORDRE_DETENTEURS ALORS
     COPIER(nomBD,"du plus partag au moins partag");
  SINON
     COPIER(nomBD,"dans l'ordre d'acquisition");
  FIN_SI

  Centrer(nomBD,nomBDS,78);
  _winputs(nomBDS);*/

fin

/*---------------------------------------------------*/

PROCEDURE EAcceptImport(int valeur)
debut
  AcceptImport=valeur;
  SI valeur==IMPORT_OK ALORS
     _menuactivate(TabSousMenus);
  SINON
     _menudeactivate(TabSousMenus);
  FIN_SI
fin

/*---------------------------------------------------*/

PROCEDURE AttenteDebut(void)
debut
  gotoxy(30,12);
  puts("JE TRAVAILLE ...");
fin

/*---------------------------------------------------*/
PROCEDURE AffichePalette(void)
debut
  int i,x,y,b;

  i=0;
  TANTQUE i<64 FAIRE
     b=15;x=25;y=3;
     _wingotoxy(x,y);
     _winputs("                                ");
     _wingotoxy(x,y+1);
     _winputs("                                ");
     TANTQUE b>7 ET i<64 FAIRE
	_tdipalette (b,i);

	SI _tdidisplaytype()==SCREEN_VGA ALORS
	   _winattr((COULEUR7<<4)+b);
	SINON
	   _winattr((b<<4)+COULEUR7);
	FIN_SI

	_wingotoxy(x,y);
	_winputc(22);

	_winattr(AttrFenPrinc);

	_wingotoxy(x-1,y+1);
	_winprintf("%2d",i);
	b--;
	i++;
	SI i==64 ALORS
	   b=15;
	FIN_SI
	x=x+3;
     FIN_TANTQUE
     _kbdread();
  FIN_TANTQUE

  PaletteBingo();

fin


