/*****************************************************************************/
/*                        SPECFNX.H                                          */
/*---------------------------------------------------------------------------*/
/* Fichier contenant les dclarations des fonctions publiques de SPEC.C      */
/*---------------------------------------------------------------------------*/
/*****************************************************************************/

extern FONCTION int TestBD(int affichage);
extern FONCTION int OuvertureBase(void);
extern PROCEDURE LectureFicCat(void);
extern PROCEDURE ModifFicCategorie(void);
extern PROCEDURE ArchiveChangement(int idEnfant, int idBrevet, int emetteur, char *pref);

/* ------------- fichier contenant la liste des brevets --------------- */
extern FONCTION int InitBrevets(void);
extern PROCEDURE AjouBrevetDansFicBrevet(int idNouveauBrevet);
extern PROCEDURE ModifBrevetDansFicBrevet(int idBrevet, int idCat, int idAuteur);
extern PROCEDURE SauveInfosBrevet(int idBrevet, char *titre, char *comment1, char *comment2);
extern PROCEDURE LitInfosBrevet(int idBrevet, char *titre, char *comment1, char *comment2);
extern PROCEDURE LitInfosBrevetAvantV3(int idBrevet, char *comment1, char *comment2);

/* ------------- fichier contenant la liste des lves --------------- */
extern PROCEDURE EnregFicEleves(int idEleveSupp);

/* ------------- fichier contenant la liste des brevets --------------- */
extern FONCTION int EnregFicBrevets(void);

/* ------------- fichiers contenant les blasons ---------------- */
extern FONCTION int LectFicEleve(int idEleve);
extern FONCTION int EnregFicEnf(int idenfant);
extern FONCTION int SuppBrevFicEnf(int idEnfant, int idBrevet, int AffFenetre, int emetteur);
extern FONCTION int AjouBrevFicEnf(int idEnfant, int idBrevet, int AffFenetre, int emetteur);
extern FONCTION int ModifObjectifFicEnf(int idEnfant, int objectif);
extern PROCEDURE LectureDesPTs(void);
extern FONCTION int LectureDuPT(int eleve, int idBrevet);
extern PROCEDURE TravailAjouteDansPT(int idBrevet, int idEnfant, int emetteur);
extern PROCEDURE EnregFicPTEnf(int enf);
extern PROCEDURE TravailEnleveDuPT(int idBrevet, int idEnfant, int emetteur);
extern PROCEDURE TravailTermineDansPT(int idBrevet, int idEnfant, int emetteur);

/* ------------- fichier contenant la liste des lves ---------------- */
extern FONCTION int InitEleves(void);
extern PROCEDURE ModifMotPasseDansFicEleves (int idEnfant, char *motPasse);

/* ------------- fichier contenant la configuration  ------------------ */
extern PROCEDURE Conv12(void);
extern PROCEDURE Conv20(void);
extern FONCTION int InitConfig(void);
extern FONCTION int LectureConfig(void);
extern PROCEDURE EnregConfig(void);


/* ------------------------ exportation ------------------------------- */
extern PROCEDURE EnregFicCatExport(char *nomFileExt);
extern PROCEDURE LectFicCatExport(char *nomFileExt);


/* ------------------------- Menu administration ----------------------- */
extern PROCEDURE far VoirMotsDePasse(int clef);
extern PROCEDURE far MenuAjoutEleves(int clef);
extern PROCEDURE far MenuSuppEleves(int clef);
extern PROCEDURE far MenuNiveauxEleves(int clef);
extern PROCEDURE Creation(void);
extern PROCEDURE far Ouvrir(int clef);
extern PROCEDURE far InitParam(int clef);
extern PROCEDURE far ModifParam(int clef);
extern PROCEDURE far ExportCat(int clef);
extern PROCEDURE far ImportCat(int clef);
