/* ==================================================================
	TDI21.H (version 2.1)

	Header for Text Display Interface

	RRC - June 1991

	Borland C++

	Copyright (c) Borland International 88,92
	All Rights Reserved.

    =================================================================
*/

#include <setjmp.h>


/* ----- gnralits */

#if !defined(__LOGIC)
#define __LOGIC

#define ON      1
#define OFF     0
#define TRUE    1
#define FALSE   0
#endif


#if !defined(__COLORS)
#define __COLORS

enum COLORS {
    BLACK,          /* dark colors */
    BLUE,
    GREEN,
    CYAN,
    RED,
    MAGENTA,
    BROWN,
    LIGHTGRAY,
    DARKGRAY,       /* light colors */
    LIGHTBLUE,
    LIGHTGREEN,
    LIGHTCYAN,
    LIGHTRED,
    LIGHTMAGENTA,
    YELLOW,
    WHITE
};
#endif

#define BLINK   128 /* blink bit */

#if !defined(__TYPE)
#define __TYPE

#define boolean         unsigned char
#define byte            unsigned char
#define word            unsigned int
#define dword           unsigned long
#endif


#define LNULL   0L


/* ------------------------------------------------------------------------ */
/*                        CONSTANTES  TDI                                   */
/* ------------------------------------------------------------------------ */
extern byte DVIOattr;
extern word DVIOpos;
extern byte DVIOtype;

/* ----- constantes clavier */
#define BEEP    '\g'
#define BS      '\b'
#define TAB     '\t'
#define LF      0x0A
#define CR      0x0D
#define ESC     0x1B
enum KEYS0 {F1=315, F2, F3, F4, F5, F6, F7, F8, F9, F10 };
enum KEYS1 {HOME=327, UP, PGUP, LEFT=331, CENTER, RIGHT, END=335, DOWN, PGDN,  INS,DEL,
	    SF1, SF2, SF3, SF4, SF5, SF6, SF7, SF8, SF9, SF10,
	    CF1, CF2, CF3, CF4, CF5, CF6, CF7, CF8, CF9, CF10,
	    AF1, AF2, AF3, AF4, AF5, AF6, AF7, AF8, AF9, AF10,
	    CPRTSC,CLEFT,CRIGHT,CEND,CPGDN,CHOME,
	    A1,A2,A3,A4,A5,A6,A7,A8,A9,A0,CPGUP=388,
	    F11,F12,SF11,SF12,CF11,CF12,AF11,AF12,
	    CUP,CMINUS,CCENTER,CPLUS,CDOWN,CINS,CDEL,CTAB,
	    AHOME=407,AUP,APGUP,ALEFT=411,ACENTER,ARIGHT,AEND=415,ADOWN,
	    APGDN,AINS,ADEL,ATAB=421
	    };
enum KEYS9 {ABSP=270,STAB,
	    ALTQ=272,ALTW,ALTE,ALTR,ALTT,ALTY,ALTU,ALTI,ALTO,ALTP,
	    AENTER=284,
	    ALTA=286,ALTS,ALTD,ALTF,ALTG,ALTH,ALTJ,ALTK,ALTL,
	    ALTZ=300,ALTX,ALTC,ALTV,ALTB,ALTN,ALTM };


/* ATTENTION : touches rserves aux claviers tendus
   ---------
	ABSP,AENTER,CENTER,F11,F12,SF11,SF12,CF11,CF12,AF11,AF12,
	CUP,CMINUS,CCENTER,CPLUS,CDOWN,CINS,CDEL,CTAB,
	AHOME,AUP,APGUP,ALEFT,ACENTER,ARIGHT,AEND,ADOWN,APGDN,AINS,ADEL,ATAB
*/

/* ----- type d'cran */
#define SCREEN_MONO     0
#define SCREEN_CGA      1
#define SCREEN_EGA      2
#define SCREEN_VGA      3

/* ----- type de cadre */
#define SIMPLE  1
#define DOUBLE  2

/* ----- type de donnes pour la saisie */
#define CHAR    1
#define STRING  2
#define LOGIC   3
#define SELECT  4
#define DATE    5
#define INT     7
#define LONG    8
#define NUM     9
#define FLOAT   10
#define BUTTON  128
#define ACTION  129
#define MEMO    130

/* ----- type d'accs pour la saisie */
#define NONE            0
#define READWRITE       1
#define READONLY        2

/* ----- type de priorit */
#define LOW             0
#define HIGH            1

/* ----- type de saisie */
#define VIEW_MODE       2
#define DB_MODE         1
#define NORMAL_MODE     0

/* ----- type de tri */
#define UTOL            0
#define LTOU            1

/* ---------------------------------------------------------------------- */
/*                        structures                                      */
/* ---------------------------------------------------------------------- */

typedef struct
{
   int   num ;
   char  *text;
}  DATAS;


typedef struct _get
{
   struct _get
	   *prev,
	   *next;

   word    pos;                 /* position  l'cran */
   int     width_scr ;          /* taille de l'cran */
   int     width_data;          /* taille des donnes  saisir */

   int     helpid;              /* index de l'aide */
   word    key;                 /* touche pour les bouttons */
   byte    prior;               /* priorit pour la sortie LOW, HIGH */

   char    *dbfield;            /* nom du champ pour les bases de donnees */
   byte    type;                /* type de champ */
   void    *data ;              /* Pointer to the Data Buffer */
   char    *message ;           /* A message displayed by 'g4message_do' */
   char    *picture ;           /* A picture entry template */
   int     num_decimals ;       /* The number of decimals for numeric entries */

   boolean upper_convert ;      /* TRUE if complete Upper Case Conversion */
   boolean password;            /* TRUE si c'est un affichage invisible */
   boolean access;              /* NONE, READONLY, READWRITE pr un champ */
				/* ON, OFF pr un bouton */

   int (*valid)(struct _get *,char *); /* appel en sortie pour vrification */
   int (*call)(struct _get *);  /* appel en entree */
   void (*action)(struct _get *); /* action pr-dfinie */
} GET;


typedef struct _choicee
{
   int dx_max, dy_max;
   int width_data;
   char *data;
   void *link;

   struct _choicee *next, *prev;
} CHOICE;


typedef struct _execkey
{
   word    key;                 /* raccourci clavier */
   char    *text;               /* texte associ */
   void    (far *sspgm)(int numclef);   /* ss-pgm */
   word    clef;                /* clef permettant d'identifier l'appel */
   boolean actived;             /* drapeau actif ou non */
   struct _execkey *next;       /* pointeur suivant */
} execkey;


typedef struct
{
   byte    dx_scr,dy_scr,       /* taille de la fentre  l'cran */
	   dx_usr,dy_usr;       /* taille de la fentre pour l'utilisateur */
   byte    border,              /* type de bordure */
	   attr_out,            /* attribut de la bordure */
	   attr_in,             /* attribut de la fentre */
	   attr_title;		/* attribut du titre de la fentre */
   boolean title,		/* prsence d'un titre */
	   cursor,              /* tat du curseur visible ou non */
	   displayed;           /* tat de la fentre visible ou non */
   byte    posx,posy;           /* position curseur interne  la fentre */
   word    posxy,               /* position curseur en absolue sur l'cran */
	   load;                /* adresse cran   (chargement) */
   char far *save;              /* adresse mmoire (sauvegarde) */
   execkey  *exec;              /* touches  accs direct associes */
   char far *help;              /* barre d'aide associe */
   GET     *first_get;          /* donnes  saisir */
   GET     *last_get;
} windows;



typedef struct
{
   word    posxy;               /* position en absolue sur l'cran */
   byte    dy_scr,dx_scr;       /* taille du menu */
   char far *save,              /* adresse mmoire (sauvegarde de l'intrieur du cadre) */
	far *load;              /* adresse mmoire (sauvegarde le dessous du cadre) */
} _frame;

typedef struct _menuitem
{
   int     id;                  /* n du choix dans le menu */
   char    *title;              /* texte */
   byte    poshigh;             /* position dans le titre de la touche en surbrillance */
   char    *help;               /* aide associe */
   word    key,                 /* touche raccouci clavier */
	   keyexec;             /* touche  accs direct ventuelle */
   word    offsetline,          /* offset cran de l'item */
	   offsethigh;          /* offset cran de la touche en surbrillance */
   boolean actived;             /* item actif ou non */
   void    (far *sspgm)(int numclef);  /* procdure associe */
   word    clef;                /* clef permettant d'identifier l'appel */
   _frame  *frame;              /* pointeur vers un menu */
   struct _menuitem
	   *before,
	   *after,              /* arborescence des choix */
	   *above,
	   *below,
	   *current;            /* permet de stocker (au niveau infrieur)
				   le choix prcdemment utilis */
} menuitem;

/* ------------------------------------------------------------------------ */
/*                     FONCTIONS  _TDI                                      */
/* ------------------------------------------------------------------------ */


void    _tdiinit(void);
/* initialisation de l'environnement TDI. A faire obligatoirement */

void    _tdiclose(void);
/* A faire obligatoirement en fin de programme */


boolean _tdisave(void);
/* sauvegarde l'cran texte. Retourne TRUE si OK */

void    _tdirestore(void);
/* raffiche l'cran texte sauvegard */


void    _tdipalette(byte col16,byte col64);
/* permet la reprogrammation des 16 couleurs principales (EGA/VGA uniquement)
   PARAM : byte col16 : numro de la couleur  modifier
	   byte col64 : numro de la couleur choisie (palette EGA)          */

void    _tdirestorepalette(void);
/* restitue les 16 couleurs de base  */


#define _tdidisplaytype()	(DVIOtype)
/* permet de connaitre le type d'cran connect
   RETOUR : SCREEN_MONO, SCREEN_CGA, SCREEN_EGA, SCREEN_VGA */


void    _tdichangefont(byte n_font,byte tab_val[]);
/* permet de reprogrammer un caractre (EGA/VGA uniquement)
   PARAM : byte n_font : code ascii du caractre  modifier
	   byte tab_val[] : matrice du caractre (EGA : 8x14, VGA : 9x16)

	   ligne 1 :   * * * * * * * *    = 255
		 2 :   . * * * * * * .    = 127
		 3 :   . . * * * * . .    = 60
		 4 :   . . . * * . . .    = 24
		...
		14 :   * * * * * * * *    = 255

	   static byte NewA[] = { 255, 127, 60, 24, ..., 255 };
	   _tdichangefont('A',NewA);

	   remarque : en VGA, on dfinit les caractres avec une matrice
	   --------   de 8x16. La 9me colonne est vide pour l'ensemble des
		      caractres sauf des codes 0xC0  0xDF qui recopient la
		      8me colonne. */



/* ------------------------------------------------------------------------ */
/*                        FONCTIONS _ERR                                    */
/* ------------------------------------------------------------------------ */


extern jmp_buf _ERRjump;
/*  permet de grer les erreurs systme */


void _errinit(byte attr_normal, byte attr_border, byte attr_erreur, byte attr_message);
/*  permet d'initialiser l'affichage des erreurs
PARAM   attr_normal     : attribut du texte
	attr_border     : attribut du pourtour de la fentre
	attr_erreur     : attribut du titre d'une fentre erreur
	attr_message    : attribut du titre d'une fentre message          */


boolean _mesdisplay(char *s);
/* affiche texte (question)
   retourne TRUE si l'utilisateur tape sur 'O'
   retourne FALSE si l'utilisateur tape sur 'N'  */


void far _errdisplay(int errcode);
/*  permet d'afficher un message d'erreur
Les textes des erreurs sont dans la structure DATAS dans inter.c
PARAM   errcode         : numro de l'erreur     */


int _errharddisplay(int,int,int,int);
/*  gestionnaire d'erreurs systme install par _errinit */



/* ------------------------------------------------------------------------ */
/*                        FONCTIONS _HELP                                   */
/* ------------------------------------------------------------------------ */


void _helpinit(byte attr_normal, byte attr_border, byte attre_titre);
/*  permet d'initialiser l'affichage de l'aide
PARAM   attr_normal     : attribut du texte
	attr_border     : attribut du pourtour de la fentre
	attr_titre      : attribut du titre                   */


void _helpfile(char *s);
/*  permet de choisir le fichier d'aide  utiliser
PARAM   *s              : nom du fichier
fichier d'aide :
--------------
@@0
 texte affich quand F1 au niveau des menus
@@<chiffre correspondant au numro de l'aide>
texte 15 lignes max.
@@-1  (obligatoire  la fin du fichier)                */


void far _helpdisplay(int helpcode);
/*  permet d'afficher de l'aide sur un sujet
PARAM   helpcode                : numro de l'aide     */



/* ------------------------------------------------------------------------- */
/*                       FONCTIONS _HELPBAR                                  */
/* ------------------------------------------------------------------------- */


void _helpbarinit(byte attr_normal, byte attr_key);
/*  permet d'initialiser la barre d'aide affiche en bas
    obligatoire pour les menus
PARAM   attr_normal     : attribut normal
	attr_key        : attribut des touches en surbrillance  */


char far *_helpbarcreate(char *s);
/*  cration d'une barre d'aide suivant le string voulu
PARAM   s               : string  afficher
			  (le caractre ^ devant une lettre permet de la
			  mettre en surbrillance)
RETOUR                  : pointeur vers une barre               */


void _helpbarshow(char far *tmp);
/*  affichage de la barre dsire avec son texte
PARAM   tmp             : pointeur vers une barre               */


void _helpbarhide(void);
/* cache la barre */


void _helpbardispose(char far *tmp);
/*  libration mmoire d'une barre
PARAM   tmp             : pointeur vers une barre              */



/* ------------------------------------------------------------------------ */
/*                    FONCTIONS _EXEC                                       */
/* ------------------------------------------------------------------------ */


void _execdefine(word key, char *s, void (far *action)(int numclef), word clef);
/*  permet d'attribuer  certaines touches des fonctions
affich en bas, c'est dfini et propre  chaque fentre.
PARAM   key             : code de la touche
	s               : aide associe
	(far action)    : procdure  appeler
	clef            : paramtre pass  la procdure lors de l'appel  */


void _execdispose(word key);
/*  permet d'annuler une touche  accs direct
PARAM   key             : code de la touche  supprimer   */


void _execactivate(word key);
/*  permet d'activer l'action d'une touche  accs direct
PARAM   key             : code de la touche  activer    */


void _execdeactivate(word key);
/*  permet de dactiver l'action d'une touche  accs direct
PARAM   key             : code de la touche  dactiver  */


void _execdisposeall(void);
/*  permet d'annuler toutes les touches d'accs direct */


void _execrefresh(void);
/*  permet de mettre  jour la barre d'affichage aprs des modifications */



/* ------------------------------------------------------------------------- */
/*                        FONCTIONS _BUTT                                    */
/* ------------------------------------------------------------------------- */


void _buttinit(byte attr_normal, byte attr_key, byte attr_select, byte attr_unselect, byte attr_shadow);
/*  permet d'initialiser les bouttons
PARAM   attr_normal     : attribut normal
	attr_key        : attribut de la touche en surbrillance
	attr_select     : attribut du bouton quand il est selectionn
	attr_unselect   : attribut du bouton quand il est inactif
	attr_shadow     : attribut de l'ombre       */


/* ------------------------------------------------------------------------- */
/*                        FONCTIONS _WIN                                     */
/* ------------------------------------------------------------------------- */
void _framedraw(int x,int y, int dx, int dy, char *titre);


void    _wininit(byte attr,byte attr_titrenonselect);
/* initialisation de l'environnement TDI. A faire obligatoirement
PARAM   byte attr : attribut (couleur caractre & couleur fond)
	byte attr_titrenonselect : attribut d'un titre non selectionn */


windows *_wincreate(int x, int y,
		    int dx, int dy,
		    char border,byte attr_in,byte attr_out,
		    char *title, byte attr_title);
/*  cration d'une fentre
PARAM   x,y             : coordonnes du coin haut-gauche
	dx,dy           : taille de la fentre
	border          : type de bordure (SIMPLE ou DOUBLE)
	attr_in         : attribut intrieur
	attr_out        : attribut du cadre
	title           : titre de la fentre
	attr_title      : attribut du titre
RETOUR                  : pointeur vers une fentre   */


windows *_winundercreate(int dx, int dy,
			 char border,byte attr_in,byte attr_out,
			 char *title, byte attr_title);
/*  permet de crer une fentre  la position actuelle
pareil que wincreate mais origine fixe par rapport  la position courante
PARAM   dx,dy           : taille de la fentre
	border          : type de bordure (SIMPLE ou DOUBLE)
	attr_in         : attribut intrieur
	attr_out        : attribut du cadre
	title           : titre de la fentre
	attr_title      : attribut du titre
RETOUR                  : pointeur vers une fentre  */


void _winselect(windows *x);
/*  permet de slectionner et affiche une fentre qui devient alors courante
PARAM   x               : pointeur vers la fentre  activer  */


void _winshow(windows *x);
/*  permet de rafficher une fentre sans qu'elle devienne la courante
PARAM   x               : pointeur de la fentre  afficher   */


void _winhide(windows *x);
/*  permet de cacher une fentre
ne peut pas se faire sur la fentre courante
PARAM   x               : pointeur de la fentre  cacher   */


void _windispose(windows *x);
/*  permet de librer la mmoire occupe par la fentre
PARAM   x               : pointeur de la fentre  librer
			  (si c'est la courante, on revient automatiquement
			   la prcdente)                  */


windows *_winprev(void);
/*  permet de connatre la fentre prcdemment affiche */


#define _winattr(a)         (DVIOattr=(a))
/*  modification de l'attribut du "futur" texte de la fentre courante */

int _winwherex(void);
/*  permet de connatre la position relative en X de la fentre courante */

int _winwherey(void);
/*  permet de connatre la position relative en Y de la fentre courante */

void _winchangeattr(int x, int y,
		    byte new_attr,int n);
/*  permet de changer l'attribut du texte dja crit dans la fentre courante
PARAM   x,y             : coordonnes dans la fentre
	new_attr        : nouvel attribut
	n               : nombre de caractres  modifier
			  (zone hors fentre non gre)    */

void _winchangetitle(char *t);
/*  changement du titre de la fentre courante
PARAM   *t              : titre  */


void _winmove(windows *tmp, int new_x, int new_y);
/*  changement de la position d'une fentre
PARAM   *tmp		: pointeur vers la fentre  modifier
	new_x		: nouvelle position absolue par rapport au haut de
	new_y           : l'cran */


void _wingotoxy(int x,int y);
/*  positionnement dans la fentre courante
PARAM   x,y             : coordonnes  */

void _winclrscr(void);
/*  effacement de la fentre courante */

void _winclreol(void);
/*  effacement de la fin de la ligne de la fentre courante */

void _winclear(int x, int y, int dx, int dy);
/*  permet d'effacer une zone dans la fentre courante
PARAM   x,y             : coordonnes du coin haut-gauche
	dx,dy           : taille du cadre   */



void _winputc(char c);
/*  affichage d'un caractre
PARAM   c               : caractre  afficher (il gre '\n','\r','\t')  */


void _winputs(char *s);
/*  affichage d'un string
PARAM   *s              : string  afficher   */


void _winputsn(char *s, int i);


void _winprintf(char *fmt,...);
/*  affichage sous forme formatte
PARAM   *fmt            : format  utiliser
	...             : liste des variables  transmettre  */


void _winscrollup(int y1,int y2,int n,byte attr);
/* >>>>> Scroll vers le haut de la fentre courante */
/*          y1          : numro de la 1re ligne
	    y2          : numro de la dernire ligne
	    n           : nbre de lignes  scroller
	    attr        : attribut    */


void _winscrolldn(int y1,int y2,int n,byte attr);
/* >>>>> Scroll vers le bas de la fentre courante */
/*          y1          : numro de la 1re ligne
	    y2          : numro de la dernire ligne
	    n           : nbre de lignes  scroller
	    attr        : attribut    */



/* ------------------------------------------------------------------------ */
/*                        FONCTIONS _MENU                                   */
/* ------------------------------------------------------------------------ */


void _menuinit(byte attr_normal, byte attr_key, byte attr_comment,
	       byte attr_selactived, byte attr_seldeactived);


menuitem *_menucreate(char *s, boolean state, word key, void (far *action)(int numclef), int clef, char *help);
/* >>>>> Permet de dfinir une entre dans les menus */
/*          *s          : pointeur vers le texte  afficher
	    high        : position du raccourci clavier (valide si l'action != NULL)
	    clef        : numro transmis au ss-pgm afin d'identifier la provenance
			  de l'appel (utile pour un ss-pgm appel depuis plusieurs endroits
	   (far *action): ss-pgm  appeler en car de selection
			  ou _menuunder pour des niveaux de menus infrieurs
			  ou NULL       pour un item commentaire (sans action)

			  ATTENTION : ils doivent tre dfinis en FAR */


void far _menuunder(int clef);
/* >>>>> permet de dfinir des menus de niveau infrieur */


void _menuend(void);
/* >>>>> permet de revenir  un menu de niveau suprieur */


void _menuline(void);


void _menurun(void);
/* >>>>> permet de donner la main au gestionnaire de menu */

void _menuactivate(menuitem *x);
/* valable uniquement pour les sous-menus */

void _menudeactivate(menuitem *x);
/* valable uniquement pour les sous-menus */


void _menuchangeitem(menuitem *tmp,char *fmt,...);
/* >>>>> Permet de redfinir un item dans un menu */
/*          n           : position du raccouci clavier
	    *fmt        : format
	    ...         : liste des variables  transmettre */


/* ------------------------------------------------------------------------- */
/*                          FONCTIONS _GET                                   */
/* ------------------------------------------------------------------------- */


/*  Les fonctions _GET sont propres  une fentre,
   _windispose effectue un _getdispose s'il n'a pas t fait */


void _getinit(byte attr_normal, byte attr_select);
/* Initialisation des fonctions _GET
PARAM byte attr_normal : attribut normal du champ
      byte attr_select : attribut quand le champ est slectionn */


GET * _getadd(int x,int y,char type,void *buf,int help,char *message);
/* message: message affich en bas
   Dclare un champ
   Remarque : si type=LOGIC, *(char *)buf='Y' ou 'N' */

GET * _getadd_dbfield(int x,int y,char *field,char *buf,int clef,char *message);

GET * _getadd_button(int x,int y,char *text ,word key, byte state, byte priority,int clef,char *message);
/* Dclare un boutton
   PARAM : char *text    : texte du boutton
           word key      : raccourci clavier
           byte state    : ON ou OFF
           byte priority : si HAUTE (HIGH), ne tient pas compte d'un ventuel GETVALID
           char *message : message dans la ligne d'aide */

/* ----------- les fonctions suivantes s'adressent uniquement --------------
                        au dernier _GET saisi                                */

void _getupper(void);    /* convertit la saisie en majuscule */

void _getprotect(void);  /* affiche des '*' au lieu du texte */

void _getaccess(byte);   /* lecture seule (READONLY) ou par dfaut (READWRITE) */

void _getpicture(char *p);  /* format comme dbase. on spcifie un caractre
                               format pour chaque lettre */

void _getwidth(int x,int y);  /* x:taille donne, y:taille affichae */

void _getvalid(int (*valid)(GET *,char *));
/* Dclare une fonction  crer de validation de la saisie
   du type int avec les 2 paramtres dfinissant les donnes de l'ancienne saisie
   et un buffer de la nouvelle saisie */

void _getcall(int (*call)(GET *));
/* Dclare une fonction qui sera appele avant l'ventuel saisie du champ.
   Celle-ci doit renvoyer TRUE ou FALSE.
   Si FALSE alors champ non modifiable */

void _getaction(void (*call)(GET *));
/* affiche une petite flche bas  cot du champ
   et dclare une fonction au cours de la modification du champ
   si l'utilisateur appuie sur la touche <flche bas> */


int  _getread(byte);
/* lecture et criture des champs. Deux modes NORMAL_MODE et DB_MODE
   Retourne CF4 (Control F4) pour fermer la fentre
   o des codes dfinis par des boutons */


GET * _getfind(char *);

void _getdisplay( GET *);
/* raffiche le champ dfini par son pointeur, un champ qui aurait t forc
    une autre valeur par la fonction dfinie dans _getaction() */

void _getshow(void);
/* affiche tous les champs dfinis par GetAdd */


void _getdispose(void);
/* obligatoire aprs getread pour librer la place alloue par les GETADD*/


/* ------------------------------------------------------------------------- */
/*                        FONCTIONS _KBD                                     */
/* ------------------------------------------------------------------------- */

word _kbdread(void);
/* pareil que getch() mais renvoyant des codes pouvant tre suprieur
    255, on peut donc utiliser ALTF5 par exemple */

void _kbdpush(word key);
/* permet de forcer un caractre dans le buffer clavier utilis par _kbdread
   PARAM : word key : code ascii tendu de la touche */


/* ------------------------------------------------------------------------- */
/*                      FONCTIONS _CHOICE                                    */
/* ------------------------------------------------------------------------- */


/* Les _CHOICE ne sont pas propres  une fentre. Ils peuvent tre globales */

void _choiceinit(byte, byte,byte);
/* dfinition des couleurs */

CHOICE *_choiceadd(char *texte);
/* dclaration d'une liste de dfilement
   PARAM : char *texte : libell du choix

   remarque : il faut imprativement mmoriser le pointeur retourn du 1er
	      choix afin de le transmettre par la suite aux autres fonctions */


CHOICE *_choiceadd_link(char *texte, void *struct_qcq);
/* mme chose que _choiceadd mais dfinit en plus un pointeur pour chaque choix
   utilisable dans la fonction dfinie par choicefunction
PARAM char * : string texte
      char * : pointeur sur une structure quelconque */


void _choiceend(void);
/* obligatoire  la fin de la dclaration de choix */


void _choicefunction(void (*call)(CHOICE *ptr));
/* dfinit la fonction appele  chaque mouvement lorsqu'on excute
   _choiceread
PARAM nom de la fonction
exemple:  _choicefunction (TOTO)
-------
	  void far TOTO (CHOICE *ptr)
	  {
	      on peut utiliser le pointeur de la selection courante.
	      on a ptr->link = struct_qcq dfinie avec _choiceadd_link
		   ptr->data = libell du choix
	  } */


void _choicesort(CHOICE *choice_ptr, int offset, int len, boolean order);
/* effectue un tri de la liste
PARAM *choice_ptr   : adresse du premier lment de la liste
      int offset    : tri en fonction du (offset) ime caractre
      int len       : sur (len) caractres
      boolean order : UTOL ou LTOU  (ordre dcroissant ou croissant) */


int _choiceread(int x, int y, int dx, int dy, int helpid, CHOICE *ptr);
/* permet d'afficher et de slectionner un lment d'une liste
PARAM int x 	 : position de la liste dans la fentre
      int y 	 :
      int dx  	 : taille de la liste
      int dy	 :
      int helpid : numro d'help (-1 pour inhiber l'appel)
   CHOICE *ptr   : adresse du premier lment de la liste
		   si adresse = NULL, affichage de Rien
RETOUR   	 : -1 si ESC ou CTRL-F4
		   -2 si liste vide
		   -3 si _choiceinit non effectu
		   0..n pour une selection */


CHOICE *_choiceptr(CHOICE *ptr, int n);
/* retourne un pointeur sur le (n+1) me choix de la liste dbutant par ptr
PARAM CHOICE * : pointeur sur le premier lment de la liste
      int n    : numro de l'lment (0.. ) */


void _choicedispose(CHOICE *ptr);
/* pour librer la mmoire de la liste dbutant par ptr */